﻿#!/usr/bin/env python
# -*- coding: utf-8 -*-
"""
This experiment was created using PsychoPy3 Experiment Builder (v2022.1.3),
    on July 15, 2022, at 15:12
If you publish work using this script the most relevant publication is:

    Peirce J, Gray JR, Simpson S, MacAskill M, Höchenberger R, Sogo H, Kastman E, Lindeløv JK. (2019) 
        PsychoPy2: Experiments in behavior made easy Behav Res 51: 195. 
        https://doi.org/10.3758/s13428-018-01193-y

"""

import psychopy
psychopy.useVersion('2022.1.3')


from psychopy import locale_setup
from psychopy import prefs
from psychopy import sound, gui, visual, core, data, event, logging, clock, colors, layout, parallel
from psychopy.constants import (NOT_STARTED, STARTED, PLAYING, PAUSED,
                                STOPPED, FINISHED, PRESSED, RELEASED, FOREVER)

import numpy as np  # whole numpy lib is available, prepend 'np.'
from numpy import (sin, cos, tan, log, log10, pi, average,
                   sqrt, std, deg2rad, rad2deg, linspace, asarray)
from numpy.random import random, randint, normal, shuffle, choice as randchoice
import os  # handy system and path functions
import sys  # to get file system encoding

import psychopy.iohub as io
from psychopy.hardware import keyboard



# Ensure that relative paths start from the same directory as this script
_thisDir = os.path.dirname(os.path.abspath(__file__))
os.chdir(_thisDir)
# Store info about the experiment session
psychopyVersion = '2022.1.3'
expName = 'MemoryTask'  # from the Builder filename that created this script
expInfo = {'participant': '', 'session': '001'}
dlg = gui.DlgFromDict(dictionary=expInfo, sortKeys=False, title=expName)
if dlg.OK == False:
    core.quit()  # user pressed cancel
expInfo['date'] = data.getDateStr()  # add a simple timestamp
expInfo['expName'] = expName
expInfo['psychopyVersion'] = psychopyVersion

# Data file name stem = absolute path + name; later add .psyexp, .csv, .log, etc
filename = _thisDir + os.sep + u'data/%s_%s_%s' % (expInfo['participant'], expName, expInfo['date'])

# An ExperimentHandler isn't essential but helps with data saving
thisExp = data.ExperimentHandler(name=expName, version='',
    extraInfo=expInfo, runtimeInfo=None,
    originPath="C:\\Users\\CNS Lab\\Desktop\\Important Psychopy Experiments GISELLE please don't delete\\MemoryExperiment\\MemoryTask_lastrun.py",
    savePickle=True, saveWideText=True,
    dataFileName=filename)
# save a log file for detail verbose info
logFile = logging.LogFile(filename+'.log', level=logging.EXP)
logging.console.setLevel(logging.WARNING)  # this outputs to the screen, not a file

endExpNow = False  # flag for 'escape' or other condition => quit the exp
frameTolerance = 0.001  # how close to onset before 'same' frame

# Start Code - component code to be run after the window creation

# Setup the Window
win = visual.Window(
    size=[1920, 1080], fullscr=False, screen=0, 
    winType='pyglet', allowGUI=True, allowStencil=False,
    monitor='testMonitor', color=[0,0,0], colorSpace='rgb',
    blendMode='avg', useFBO=True, 
    units='height')
# store frame rate of monitor if we can measure it
expInfo['frameRate'] = win.getActualFrameRate()
if expInfo['frameRate'] != None:
    frameDur = 1.0 / round(expInfo['frameRate'])
else:
    frameDur = 1.0 / 60.0  # could not measure, so guess
# Setup ioHub
ioConfig = {}

# Setup iohub keyboard
ioConfig['Keyboard'] = dict(use_keymap='psychopy')

ioSession = '1'
if 'session' in expInfo:
    ioSession = str(expInfo['session'])
ioServer = io.launchHubServer(window=win, **ioConfig)
eyetracker = None

# create a default keyboard (e.g. to check for escape)
defaultKeyboard = keyboard.Keyboard(backend='iohub')

# Initialize components for Routine "ExperimentInit"
ExperimentInitClock = core.Clock()
import random, xlrd

#randomize the seed
random.seed()

#create array for stimulus files
stimulusFiles = [
'resources/stimuli/Alcohol.xls',
'resources/stimuli/Animal.xls',
'resources/stimuli/BodyPart.xls',
'resources/stimuli/Colour.xls',
'resources/stimuli/Condiment.xls',
'resources/stimuli/Country.xls',
'resources/stimuli/Dwelling.xls',
'resources/stimuli/Fabric.xls',
'resources/stimuli/Fish.xls',
'resources/stimuli/Fruit.xls',
'resources/stimuli/Furniture.xls',
'resources/stimuli/GardenTool.xls',
'resources/stimuli/Insect.xls',
'resources/stimuli/Occupation.xls',
'resources/stimuli/Vegetable.xls',
'resources/stimuli/Vehicle.xls',
]

random.shuffle(stimulusFiles)

#stimulus file
#infile = 'resources/stimuli/StimSet.xls'

#define level class
class Level:
    def __init__(self, numTrials, numEncoding, duration):
        self.numTrials = numTrials
        self.numEncoding = numEncoding
        self.duration = duration

#define the number of items in each block
#difficulty level 0
numTrialsL0 = 55
numEncodingL0 = 30
durationL0 = 1.4

levelZero = Level(numTrialsL0, numEncodingL0, durationL0)

#difficulty level 1
numTrialsL1 = 61
numEncodingL1 = 36
durationL1 = 1.2

levelOne = Level(numTrialsL1, numEncodingL1, durationL1)

#difficulty level 2
numTrialsL2 = 67
numEncodingL2 = 42
durationL2 = 1.0

levelTwo = Level(numTrialsL2, numEncodingL2, durationL2)

#difficulty level 3
numTrialsL3 = 73
numEncodingL3 = 48
durationL3 = 0.8

levelThree = Level(numTrialsL3, numEncodingL3, durationL3)

#define the difficulty level array
difficultyLevels = [levelZero, levelOne, levelTwo, levelThree]

#number of testing phase trials per block
numberTestTrials = 50

#define current block index
currentBlockIndex  = 0

#set number of blocks
numberOfBlocks = 4

#set initial difficulty level
currentLevelIndex = 1
currentDifficultyLevel = difficultyLevels[currentLevelIndex]

# Initialize components for Routine "WelcomeScreen"
WelcomeScreenClock = core.Clock()
textWelcome = visual.TextStim(win=win, name='textWelcome',
    text='Welcome to the experiment.\n\nPlease press space to contiue.',
    font='Open Sans',
    pos=(0, 0), height=0.05, wrapWidth=None, ori=0.0, 
    color='white', colorSpace='rgb', opacity=None, 
    languageStyle='LTR',
    depth=0.0);
keyWelcone = keyboard.Keyboard()

# Initialize components for Routine "blockWordLoader"
blockWordLoaderClock = core.Clock()
#current workbook/category we're on
currentWorkbookIndex = 0

#limit on number or words from a single category
categoryLimit = 19

# Initialize components for Routine "EncodingInstruct"
EncodingInstructClock = core.Clock()
textEncodingInstruct = visual.TextStim(win=win, name='textEncodingInstruct',
    text='In this phase of the experiments, you will see a series of words.\n\nDo your best to remember them.\n\nPress space to continue.',
    font='Open Sans',
    pos=(0, 0), height=0.05, wrapWidth=None, ori=0.0, 
    color='white', colorSpace='rgb', opacity=None, 
    languageStyle='LTR',
    depth=0.0);
keyEncodingInstruct = keyboard.Keyboard()

# Initialize components for Routine "Fixation"
FixationClock = core.Clock()
textFixation = visual.TextStim(win=win, name='textFixation',
    text='+',
    font='Open Sans',
    pos=(0, 0), height=0.05, wrapWidth=None, ori=0.0, 
    color='white', colorSpace='rgb', opacity=None, 
    languageStyle='LTR',
    depth=0.0);
jitterRange = np.arange(0.8, 1.2, 0.1)
shuffle(jitterRange)
jitter = jitterRange[0]

# Initialize components for Routine "EncodingTrial"
EncodingTrialClock = core.Clock()
textEncodingTrial = visual.TextStim(win=win, name='textEncodingTrial',
    text='',
    font='Open Sans',
    pos=(0, 0), height=0.05, wrapWidth=None, ori=0.0, 
    color='white', colorSpace='rgb', opacity=None, 
    languageStyle='LTR',
    depth=0.0);
key_respEncoding = keyboard.Keyboard()
currentEncodingWord = 0

# Initialize components for Routine "EncodingEnd"
EncodingEndClock = core.Clock()
textEncodingEnd = visual.TextStim(win=win, name='textEncodingEnd',
    text="Congratulations, you have completed this phase of the experiment.\n\nWhen you're ready, press space to move on to the next phase",
    font='Open Sans',
    pos=(0, 0), height=0.05, wrapWidth=None, ori=0.0, 
    color='white', colorSpace='rgb', opacity=None, 
    languageStyle='LTR',
    depth=0.0);
keyEncodingEnd = keyboard.Keyboard()

# Initialize components for Routine "PreTestCode"
PreTestCodeClock = core.Clock()

# Initialize components for Routine "TestingInstruct"
TestingInstructClock = core.Clock()
textTestingInstruct = visual.TextStim(win=win, name='textTestingInstruct',
    text='In this phase of the experiment, you will see a mix of new and previously seen words.',
    font='Open Sans',
    pos=(0, 0.2), height=0.05, wrapWidth=None, ori=0.0, 
    color='white', colorSpace='rgb', opacity=None, 
    languageStyle='LTR',
    depth=0.0);
keyTestingInstruct = keyboard.Keyboard()
imageFKey = visual.ImageStim(
    win=win,
    name='imageFKey', 
    image='resources/img/f_key.png', mask=None, anchor='center',
    ori=0.0, pos=(-0.4, 0), size=(0.1, 0.1),
    color=[1,1,1], colorSpace='rgb', opacity=None,
    flipHoriz=False, flipVert=False,
    texRes=128.0, interpolate=True, depth=-2.0)
imageJKey = visual.ImageStim(
    win=win,
    name='imageJKey', 
    image='resources/img/j_key.png', mask=None, anchor='center',
    ori=0.0, pos=(0.4, 0), size=(0.1, 0.1),
    color=[1,1,1], colorSpace='rgb', opacity=None,
    flipHoriz=False, flipVert=False,
    texRes=128.0, interpolate=True, depth=-3.0)
textTestingInstructSpace = visual.TextStim(win=win, name='textTestingInstructSpace',
    text='Press space to continue.',
    font='Open Sans',
    pos=(0, -0.3), height=0.05, wrapWidth=None, ori=0.0, 
    color='white', colorSpace='rgb', opacity=None, 
    languageStyle='LTR',
    depth=-4.0);
textTestingInstructF = visual.TextStim(win=win, name='textTestingInstructF',
    text='Press F if you have not seen the word.',
    font='Open Sans',
    pos=(-0.4, -0.1), height=0.05, wrapWidth=0.5, ori=0.0, 
    color='white', colorSpace='rgb', opacity=None, 
    languageStyle='LTR',
    depth=-5.0);
textTestingInstructJ = visual.TextStim(win=win, name='textTestingInstructJ',
    text='Press J if you have seen the word.',
    font='Open Sans',
    pos=(0.4, -0.1), height=0.05, wrapWidth=0.5, ori=0.0, 
    color='white', colorSpace='rgb', opacity=None, 
    languageStyle='LTR',
    depth=-6.0);
p_port_init = parallel.ParallelPort(address='0x3FF8')

# Initialize components for Routine "TestInitCode"
TestInitCodeClock = core.Clock()
# set up counters
currentTestWord = 0
correctCounter = 0
errorCounter = 0
errorCounterCurrentBlock = 0
hitCounter = 0
missCounter = 0
falseAlarmCounter = 0
correctRejectionCounter = 0
answeredCounter = 0
unansweredCounter = 0
answered = False
confidenceFalseAlarmCounter = 0
confidenceCorrectRejectionCounter = 0

# Initialize components for Routine "Fixation"
FixationClock = core.Clock()
textFixation = visual.TextStim(win=win, name='textFixation',
    text='+',
    font='Open Sans',
    pos=(0, 0), height=0.05, wrapWidth=None, ori=0.0, 
    color='white', colorSpace='rgb', opacity=None, 
    languageStyle='LTR',
    depth=0.0);
jitterRange = np.arange(0.8, 1.2, 0.1)
shuffle(jitterRange)
jitter = jitterRange[0]

# Initialize components for Routine "TestingTrial"
TestingTrialClock = core.Clock()
textTestingTrial = visual.TextStim(win=win, name='textTestingTrial',
    text='',
    font='Open Sans',
    pos=(0, 0), height=0.05, wrapWidth=None, ori=0.0, 
    color='white', colorSpace='rgb', opacity=None, 
    languageStyle='LTR',
    depth=0.0);
key_respTrial = keyboard.Keyboard()
p_port_trial_new = parallel.ParallelPort(address='0x3FF8')
p_port_trial_old = parallel.ParallelPort(address='0x3FF8')
p_port_incorrect = parallel.ParallelPort(address='0x3FF8')

# Initialize components for Routine "CorrectnessSelect"
CorrectnessSelectClock = core.Clock()
nRepsCorrect = 0
nRepsIncorrect = 0

# Initialize components for Routine "Fixation"
FixationClock = core.Clock()
textFixation = visual.TextStim(win=win, name='textFixation',
    text='+',
    font='Open Sans',
    pos=(0, 0), height=0.05, wrapWidth=None, ori=0.0, 
    color='white', colorSpace='rgb', opacity=None, 
    languageStyle='LTR',
    depth=0.0);
jitterRange = np.arange(0.8, 1.2, 0.1)
shuffle(jitterRange)
jitter = jitterRange[0]

# Initialize components for Routine "ConfidenceTrial"
ConfidenceTrialClock = core.Clock()
textConfidenceTrial = visual.TextStim(win=win, name='textConfidenceTrial',
    text='What is your confidence level?',
    font='Open Sans',
    pos=(0, 0.2), height=0.05, wrapWidth=None, ori=0.0, 
    color='white', colorSpace='rgb', opacity=None, 
    languageStyle='LTR',
    depth=0.0);
textTestingConfidenceF = visual.TextStim(win=win, name='textTestingConfidenceF',
    text='Low',
    font='Open Sans',
    pos=(-0.4, -0.1), height=0.05, wrapWidth=0.5, ori=0.0, 
    color='white', colorSpace='rgb', opacity=None, 
    languageStyle='LTR',
    depth=-1.0);
textTestingConfidenceJ = visual.TextStim(win=win, name='textTestingConfidenceJ',
    text='High',
    font='Open Sans',
    pos=(0.4, -0.1), height=0.05, wrapWidth=0.5, ori=0.0, 
    color='white', colorSpace='rgb', opacity=None, 
    languageStyle='LTR',
    depth=-2.0);
key_respConfidence = keyboard.Keyboard()

# Initialize components for Routine "Fixation"
FixationClock = core.Clock()
textFixation = visual.TextStim(win=win, name='textFixation',
    text='+',
    font='Open Sans',
    pos=(0, 0), height=0.05, wrapWidth=None, ori=0.0, 
    color='white', colorSpace='rgb', opacity=None, 
    languageStyle='LTR',
    depth=0.0);
jitterRange = np.arange(0.8, 1.2, 0.1)
shuffle(jitterRange)
jitter = jitterRange[0]

# Initialize components for Routine "TestingCorrect"
TestingCorrectClock = core.Clock()
textTestingCorrect = visual.TextStim(win=win, name='textTestingCorrect',
    text='Your answer was:',
    font='Open Sans',
    pos=(0, 0.15), height=0.05, wrapWidth=None, ori=0.0, 
    color='white', colorSpace='rgb', opacity=None, 
    languageStyle='LTR',
    depth=0.0);
imageTestingCorrect = visual.ImageStim(
    win=win,
    name='imageTestingCorrect', 
    image='resources/img/thumbs_up.png', mask=None, anchor='center',
    ori=0.0, pos=(0, -0.05), size=(0.15, 0.15),
    color=[1,1,1], colorSpace='rgb', opacity=None,
    flipHoriz=False, flipVert=False,
    texRes=128.0, interpolate=True, depth=-1.0)

# Initialize components for Routine "TestingIncorrect"
TestingIncorrectClock = core.Clock()
textTestingIncorrect = visual.TextStim(win=win, name='textTestingIncorrect',
    text='Your answer was',
    font='Open Sans',
    pos=(0, 0.15), height=0.05, wrapWidth=None, ori=0.0, 
    color='white', colorSpace='rgb', opacity=None, 
    languageStyle='LTR',
    depth=0.0);
imageTestingIncorrect = visual.ImageStim(
    win=win,
    name='imageTestingIncorrect', 
    image='resources/img/thumbs_down.png', mask=None, anchor='center',
    ori=0.0, pos=(0, -0.05), size=(0.15, 0.15),
    color=[1,1,1], colorSpace='rgb', opacity=None,
    flipHoriz=False, flipVert=False,
    texRes=128.0, interpolate=True, depth=-1.0)

# Initialize components for Routine "TestEndCode"
TestEndCodeClock = core.Clock()

# Initialize components for Routine "BlockSelect"
BlockSelectClock = core.Clock()

# Initialize components for Routine "TestingBlockEnd"
TestingBlockEndClock = core.Clock()
textTestBlockEnd = visual.TextStim(win=win, name='textTestBlockEnd',
    text="Congratulations, you have completed this phase of the experiment.\n\nWhen you're ready, press space to move on to the next phase",
    font='Open Sans',
    pos=(0, 0), height=0.05, wrapWidth=None, ori=0.0, 
    color='white', colorSpace='rgb', opacity=None, 
    languageStyle='LTR',
    depth=0.0);
keyTestBlockEnd = keyboard.Keyboard()

# Initialize components for Routine "ExperimentEnd"
ExperimentEndClock = core.Clock()
textExperimentEnd = visual.TextStim(win=win, name='textExperimentEnd',
    text='Thank you, the experiment is now over.',
    font='Open Sans',
    pos=(0, 0), height=0.05, wrapWidth=None, ori=0.0, 
    color='white', colorSpace='rgb', opacity=None, 
    languageStyle='LTR',
    depth=0.0);
keyExperimentEnd = keyboard.Keyboard()
import pandas as pd

# Create some handy timers
globalClock = core.Clock()  # to track the time since experiment started
routineTimer = core.CountdownTimer()  # to track time remaining of each (non-slip) routine 

# ------Prepare to start Routine "ExperimentInit"-------
continueRoutine = True
# update component parameters for each repeat
# keep track of which components have finished
ExperimentInitComponents = []
for thisComponent in ExperimentInitComponents:
    thisComponent.tStart = None
    thisComponent.tStop = None
    thisComponent.tStartRefresh = None
    thisComponent.tStopRefresh = None
    if hasattr(thisComponent, 'status'):
        thisComponent.status = NOT_STARTED
# reset timers
t = 0
_timeToFirstFrame = win.getFutureFlipTime(clock="now")
ExperimentInitClock.reset(-_timeToFirstFrame)  # t0 is time of first possible flip
frameN = -1

# -------Run Routine "ExperimentInit"-------
while continueRoutine:
    # get current time
    t = ExperimentInitClock.getTime()
    tThisFlip = win.getFutureFlipTime(clock=ExperimentInitClock)
    tThisFlipGlobal = win.getFutureFlipTime(clock=None)
    frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
    # update/draw components on each frame
    
    # check for quit (typically the Esc key)
    if endExpNow or defaultKeyboard.getKeys(keyList=["escape"]):
        core.quit()
    
    # check if all components have finished
    if not continueRoutine:  # a component has requested a forced-end of Routine
        break
    continueRoutine = False  # will revert to True if at least one component still running
    for thisComponent in ExperimentInitComponents:
        if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
            continueRoutine = True
            break  # at least one component has not yet finished
    
    # refresh the screen
    if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
        win.flip()

# -------Ending Routine "ExperimentInit"-------
for thisComponent in ExperimentInitComponents:
    if hasattr(thisComponent, "setAutoDraw"):
        thisComponent.setAutoDraw(False)
# the Routine "ExperimentInit" was not non-slip safe, so reset the non-slip timer
routineTimer.reset()

# ------Prepare to start Routine "WelcomeScreen"-------
continueRoutine = True
# update component parameters for each repeat
keyWelcone.keys = []
keyWelcone.rt = []
_keyWelcone_allKeys = []
# keep track of which components have finished
WelcomeScreenComponents = [textWelcome, keyWelcone]
for thisComponent in WelcomeScreenComponents:
    thisComponent.tStart = None
    thisComponent.tStop = None
    thisComponent.tStartRefresh = None
    thisComponent.tStopRefresh = None
    if hasattr(thisComponent, 'status'):
        thisComponent.status = NOT_STARTED
# reset timers
t = 0
_timeToFirstFrame = win.getFutureFlipTime(clock="now")
WelcomeScreenClock.reset(-_timeToFirstFrame)  # t0 is time of first possible flip
frameN = -1

# -------Run Routine "WelcomeScreen"-------
while continueRoutine:
    # get current time
    t = WelcomeScreenClock.getTime()
    tThisFlip = win.getFutureFlipTime(clock=WelcomeScreenClock)
    tThisFlipGlobal = win.getFutureFlipTime(clock=None)
    frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
    # update/draw components on each frame
    
    # *textWelcome* updates
    if textWelcome.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
        # keep track of start time/frame for later
        textWelcome.frameNStart = frameN  # exact frame index
        textWelcome.tStart = t  # local t and not account for scr refresh
        textWelcome.tStartRefresh = tThisFlipGlobal  # on global time
        win.timeOnFlip(textWelcome, 'tStartRefresh')  # time at next scr refresh
        textWelcome.setAutoDraw(True)
    
    # *keyWelcone* updates
    waitOnFlip = False
    if keyWelcone.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
        # keep track of start time/frame for later
        keyWelcone.frameNStart = frameN  # exact frame index
        keyWelcone.tStart = t  # local t and not account for scr refresh
        keyWelcone.tStartRefresh = tThisFlipGlobal  # on global time
        win.timeOnFlip(keyWelcone, 'tStartRefresh')  # time at next scr refresh
        keyWelcone.status = STARTED
        # keyboard checking is just starting
        waitOnFlip = True
        win.callOnFlip(keyWelcone.clock.reset)  # t=0 on next screen flip
        win.callOnFlip(keyWelcone.clearEvents, eventType='keyboard')  # clear events on next screen flip
    if keyWelcone.status == STARTED and not waitOnFlip:
        theseKeys = keyWelcone.getKeys(keyList=['space'], waitRelease=False)
        _keyWelcone_allKeys.extend(theseKeys)
        if len(_keyWelcone_allKeys):
            keyWelcone.keys = _keyWelcone_allKeys[-1].name  # just the last key pressed
            keyWelcone.rt = _keyWelcone_allKeys[-1].rt
            # a response ends the routine
            continueRoutine = False
    
    # check for quit (typically the Esc key)
    if endExpNow or defaultKeyboard.getKeys(keyList=["escape"]):
        core.quit()
    
    # check if all components have finished
    if not continueRoutine:  # a component has requested a forced-end of Routine
        break
    continueRoutine = False  # will revert to True if at least one component still running
    for thisComponent in WelcomeScreenComponents:
        if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
            continueRoutine = True
            break  # at least one component has not yet finished
    
    # refresh the screen
    if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
        win.flip()

# -------Ending Routine "WelcomeScreen"-------
for thisComponent in WelcomeScreenComponents:
    if hasattr(thisComponent, "setAutoDraw"):
        thisComponent.setAutoDraw(False)
# the Routine "WelcomeScreen" was not non-slip safe, so reset the non-slip timer
routineTimer.reset()

# set up handler to look after randomisation of conditions etc
trialsExperimentBlock = data.TrialHandler(nReps=numberOfBlocks, method='sequential', 
    extraInfo=expInfo, originPath=-1,
    trialList=[None],
    seed=None, name='trialsExperimentBlock')
thisExp.addLoop(trialsExperimentBlock)  # add the loop to the experiment
thisTrialsExperimentBlock = trialsExperimentBlock.trialList[0]  # so we can initialise stimuli with some values
# abbreviate parameter names if possible (e.g. rgb = thisTrialsExperimentBlock.rgb)
if thisTrialsExperimentBlock != None:
    for paramName in thisTrialsExperimentBlock:
        exec('{} = thisTrialsExperimentBlock[paramName]'.format(paramName))

for thisTrialsExperimentBlock in trialsExperimentBlock:
    currentLoop = trialsExperimentBlock
    # abbreviate parameter names if possible (e.g. rgb = thisTrialsExperimentBlock.rgb)
    if thisTrialsExperimentBlock != None:
        for paramName in thisTrialsExperimentBlock:
            exec('{} = thisTrialsExperimentBlock[paramName]'.format(paramName))
    
    # ------Prepare to start Routine "blockWordLoader"-------
    continueRoutine = True
    # update component parameters for each repeat
    #arrays for the stimuli
    words = []
    
    #load in each sheet(category) until we have at least the 
    #total number of words for this difficulty level
    while(len(words) < currentDifficultyLevel.numTrials):
        
        #access the stimulus file
        infile = stimulusFiles[currentWorkbookIndex]
        inbook = xlrd.open_workbook(infile)
        insheet = inbook.sheet_by_index(0)
        
        #by default, set limit to be total number or rows 
        limit = insheet.nrows
        if (insheet.nrows > categoryLimit):
            limit = categoryLimit
    
        #read the stimuli from our sheet
        for rowx in range(1, limit + 1):
            row = insheet.row_values(rowx)
            #print(row[0])
            words.append(row[0])
            
        print(len(words))
        print(currentDifficultyLevel.numTrials)
        currentWorkbookIndex += 1
    
    #randomize order of the word array
    random.shuffle(words)
    
    #arrays for final stimuli
    encodingWordItem = []
    wordItem = []
    oldNew = []
    correctAnswer = []
    correctTrigger = []
    
    #create encoding stimulus list
    for i in range(currentDifficultyLevel.numEncoding):
        encodingWordItem.append(words[i])
    
    #create testing phase stimulus list
    for i in range(currentDifficultyLevel.numTrials):
        if i < 25:
            wordItem.append(words[i])
            oldNew.append("old")
            correctAnswer.append("j")
            correctTrigger.append(10)
        if i >= int(currentDifficultyLevel.numEncoding) and len(wordItem) <= numberTestTrials:
            wordItem.append(words[i])
            oldNew.append("new")
            correctAnswer.append("f")
            correctTrigger.append(11)
            
    #ALL TESTING STUFF BELOQ
    #print(encodingWordItem)
    #print(wordItem)
    #print(oldNew)
    
    #access the stimulus file
    #inbook = xlrd.open_workbook(infile)
    #insheet = inbook.sheet_by_index(0)
    
    #read the stimuli from our sheet
    #for rowx in range(1, currentDifficultyLevel.numTrials + 1):
    #    row = insheet.row_values(rowx)
    #    #print(row[0])
    #    words.append(row[0])
    # keep track of which components have finished
    blockWordLoaderComponents = []
    for thisComponent in blockWordLoaderComponents:
        thisComponent.tStart = None
        thisComponent.tStop = None
        thisComponent.tStartRefresh = None
        thisComponent.tStopRefresh = None
        if hasattr(thisComponent, 'status'):
            thisComponent.status = NOT_STARTED
    # reset timers
    t = 0
    _timeToFirstFrame = win.getFutureFlipTime(clock="now")
    blockWordLoaderClock.reset(-_timeToFirstFrame)  # t0 is time of first possible flip
    frameN = -1
    
    # -------Run Routine "blockWordLoader"-------
    while continueRoutine:
        # get current time
        t = blockWordLoaderClock.getTime()
        tThisFlip = win.getFutureFlipTime(clock=blockWordLoaderClock)
        tThisFlipGlobal = win.getFutureFlipTime(clock=None)
        frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
        # update/draw components on each frame
        
        # check for quit (typically the Esc key)
        if endExpNow or defaultKeyboard.getKeys(keyList=["escape"]):
            core.quit()
        
        # check if all components have finished
        if not continueRoutine:  # a component has requested a forced-end of Routine
            break
        continueRoutine = False  # will revert to True if at least one component still running
        for thisComponent in blockWordLoaderComponents:
            if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
                continueRoutine = True
                break  # at least one component has not yet finished
        
        # refresh the screen
        if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
            win.flip()
    
    # -------Ending Routine "blockWordLoader"-------
    for thisComponent in blockWordLoaderComponents:
        if hasattr(thisComponent, "setAutoDraw"):
            thisComponent.setAutoDraw(False)
    # the Routine "blockWordLoader" was not non-slip safe, so reset the non-slip timer
    routineTimer.reset()
    
    # ------Prepare to start Routine "EncodingInstruct"-------
    continueRoutine = True
    # update component parameters for each repeat
    keyEncodingInstruct.keys = []
    keyEncodingInstruct.rt = []
    _keyEncodingInstruct_allKeys = []
    # keep track of which components have finished
    EncodingInstructComponents = [textEncodingInstruct, keyEncodingInstruct]
    for thisComponent in EncodingInstructComponents:
        thisComponent.tStart = None
        thisComponent.tStop = None
        thisComponent.tStartRefresh = None
        thisComponent.tStopRefresh = None
        if hasattr(thisComponent, 'status'):
            thisComponent.status = NOT_STARTED
    # reset timers
    t = 0
    _timeToFirstFrame = win.getFutureFlipTime(clock="now")
    EncodingInstructClock.reset(-_timeToFirstFrame)  # t0 is time of first possible flip
    frameN = -1
    
    # -------Run Routine "EncodingInstruct"-------
    while continueRoutine:
        # get current time
        t = EncodingInstructClock.getTime()
        tThisFlip = win.getFutureFlipTime(clock=EncodingInstructClock)
        tThisFlipGlobal = win.getFutureFlipTime(clock=None)
        frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
        # update/draw components on each frame
        
        # *textEncodingInstruct* updates
        if textEncodingInstruct.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
            # keep track of start time/frame for later
            textEncodingInstruct.frameNStart = frameN  # exact frame index
            textEncodingInstruct.tStart = t  # local t and not account for scr refresh
            textEncodingInstruct.tStartRefresh = tThisFlipGlobal  # on global time
            win.timeOnFlip(textEncodingInstruct, 'tStartRefresh')  # time at next scr refresh
            textEncodingInstruct.setAutoDraw(True)
        
        # *keyEncodingInstruct* updates
        waitOnFlip = False
        if keyEncodingInstruct.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
            # keep track of start time/frame for later
            keyEncodingInstruct.frameNStart = frameN  # exact frame index
            keyEncodingInstruct.tStart = t  # local t and not account for scr refresh
            keyEncodingInstruct.tStartRefresh = tThisFlipGlobal  # on global time
            win.timeOnFlip(keyEncodingInstruct, 'tStartRefresh')  # time at next scr refresh
            keyEncodingInstruct.status = STARTED
            # keyboard checking is just starting
            waitOnFlip = True
            win.callOnFlip(keyEncodingInstruct.clock.reset)  # t=0 on next screen flip
            win.callOnFlip(keyEncodingInstruct.clearEvents, eventType='keyboard')  # clear events on next screen flip
        if keyEncodingInstruct.status == STARTED and not waitOnFlip:
            theseKeys = keyEncodingInstruct.getKeys(keyList=['space'], waitRelease=False)
            _keyEncodingInstruct_allKeys.extend(theseKeys)
            if len(_keyEncodingInstruct_allKeys):
                keyEncodingInstruct.keys = _keyEncodingInstruct_allKeys[-1].name  # just the last key pressed
                keyEncodingInstruct.rt = _keyEncodingInstruct_allKeys[-1].rt
                # a response ends the routine
                continueRoutine = False
        
        # check for quit (typically the Esc key)
        if endExpNow or defaultKeyboard.getKeys(keyList=["escape"]):
            core.quit()
        
        # check if all components have finished
        if not continueRoutine:  # a component has requested a forced-end of Routine
            break
        continueRoutine = False  # will revert to True if at least one component still running
        for thisComponent in EncodingInstructComponents:
            if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
                continueRoutine = True
                break  # at least one component has not yet finished
        
        # refresh the screen
        if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
            win.flip()
    
    # -------Ending Routine "EncodingInstruct"-------
    for thisComponent in EncodingInstructComponents:
        if hasattr(thisComponent, "setAutoDraw"):
            thisComponent.setAutoDraw(False)
    # the Routine "EncodingInstruct" was not non-slip safe, so reset the non-slip timer
    routineTimer.reset()
    
    # set up handler to look after randomisation of conditions etc
    trialsEncodingBlock = data.TrialHandler(nReps=currentDifficultyLevel.numEncoding, method='random', 
        extraInfo=expInfo, originPath=-1,
        trialList=[None],
        seed=None, name='trialsEncodingBlock')
    thisExp.addLoop(trialsEncodingBlock)  # add the loop to the experiment
    thisTrialsEncodingBlock = trialsEncodingBlock.trialList[0]  # so we can initialise stimuli with some values
    # abbreviate parameter names if possible (e.g. rgb = thisTrialsEncodingBlock.rgb)
    if thisTrialsEncodingBlock != None:
        for paramName in thisTrialsEncodingBlock:
            exec('{} = thisTrialsEncodingBlock[paramName]'.format(paramName))
    
    for thisTrialsEncodingBlock in trialsEncodingBlock:
        currentLoop = trialsEncodingBlock
        # abbreviate parameter names if possible (e.g. rgb = thisTrialsEncodingBlock.rgb)
        if thisTrialsEncodingBlock != None:
            for paramName in thisTrialsEncodingBlock:
                exec('{} = thisTrialsEncodingBlock[paramName]'.format(paramName))
        
        # ------Prepare to start Routine "Fixation"-------
        continueRoutine = True
        # update component parameters for each repeat
        jitterRange = np.arange(0.9, 1.2, 0.1)
        shuffle(jitterRange)
        jitter = jitterRange[0]
        # keep track of which components have finished
        FixationComponents = [textFixation]
        for thisComponent in FixationComponents:
            thisComponent.tStart = None
            thisComponent.tStop = None
            thisComponent.tStartRefresh = None
            thisComponent.tStopRefresh = None
            if hasattr(thisComponent, 'status'):
                thisComponent.status = NOT_STARTED
        # reset timers
        t = 0
        _timeToFirstFrame = win.getFutureFlipTime(clock="now")
        FixationClock.reset(-_timeToFirstFrame)  # t0 is time of first possible flip
        frameN = -1
        
        # -------Run Routine "Fixation"-------
        while continueRoutine:
            # get current time
            t = FixationClock.getTime()
            tThisFlip = win.getFutureFlipTime(clock=FixationClock)
            tThisFlipGlobal = win.getFutureFlipTime(clock=None)
            frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
            # update/draw components on each frame
            
            # *textFixation* updates
            if textFixation.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
                # keep track of start time/frame for later
                textFixation.frameNStart = frameN  # exact frame index
                textFixation.tStart = t  # local t and not account for scr refresh
                textFixation.tStartRefresh = tThisFlipGlobal  # on global time
                win.timeOnFlip(textFixation, 'tStartRefresh')  # time at next scr refresh
                textFixation.setAutoDraw(True)
            if textFixation.status == STARTED:
                # is it time to stop? (based on global clock, using actual start)
                if tThisFlipGlobal > textFixation.tStartRefresh + jitter-frameTolerance:
                    # keep track of stop time/frame for later
                    textFixation.tStop = t  # not accounting for scr refresh
                    textFixation.frameNStop = frameN  # exact frame index
                    win.timeOnFlip(textFixation, 'tStopRefresh')  # time at next scr refresh
                    textFixation.setAutoDraw(False)
            
            # check for quit (typically the Esc key)
            if endExpNow or defaultKeyboard.getKeys(keyList=["escape"]):
                core.quit()
            
            # check if all components have finished
            if not continueRoutine:  # a component has requested a forced-end of Routine
                break
            continueRoutine = False  # will revert to True if at least one component still running
            for thisComponent in FixationComponents:
                if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
                    continueRoutine = True
                    break  # at least one component has not yet finished
            
            # refresh the screen
            if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
                win.flip()
        
        # -------Ending Routine "Fixation"-------
        for thisComponent in FixationComponents:
            if hasattr(thisComponent, "setAutoDraw"):
                thisComponent.setAutoDraw(False)
        # the Routine "Fixation" was not non-slip safe, so reset the non-slip timer
        routineTimer.reset()
        
        # ------Prepare to start Routine "EncodingTrial"-------
        continueRoutine = True
        # update component parameters for each repeat
        textEncodingTrial.setText(encodingWordItem[currentEncodingWord])
        key_respEncoding.keys = []
        key_respEncoding.rt = []
        _key_respEncoding_allKeys = []
        # keep track of which components have finished
        EncodingTrialComponents = [textEncodingTrial, key_respEncoding]
        for thisComponent in EncodingTrialComponents:
            thisComponent.tStart = None
            thisComponent.tStop = None
            thisComponent.tStartRefresh = None
            thisComponent.tStopRefresh = None
            if hasattr(thisComponent, 'status'):
                thisComponent.status = NOT_STARTED
        # reset timers
        t = 0
        _timeToFirstFrame = win.getFutureFlipTime(clock="now")
        EncodingTrialClock.reset(-_timeToFirstFrame)  # t0 is time of first possible flip
        frameN = -1
        
        # -------Run Routine "EncodingTrial"-------
        while continueRoutine:
            # get current time
            t = EncodingTrialClock.getTime()
            tThisFlip = win.getFutureFlipTime(clock=EncodingTrialClock)
            tThisFlipGlobal = win.getFutureFlipTime(clock=None)
            frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
            # update/draw components on each frame
            
            # *textEncodingTrial* updates
            if textEncodingTrial.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
                # keep track of start time/frame for later
                textEncodingTrial.frameNStart = frameN  # exact frame index
                textEncodingTrial.tStart = t  # local t and not account for scr refresh
                textEncodingTrial.tStartRefresh = tThisFlipGlobal  # on global time
                win.timeOnFlip(textEncodingTrial, 'tStartRefresh')  # time at next scr refresh
                textEncodingTrial.setAutoDraw(True)
            if textEncodingTrial.status == STARTED:
                # is it time to stop? (based on global clock, using actual start)
                if tThisFlipGlobal > textEncodingTrial.tStartRefresh + currentDifficultyLevel.duration-frameTolerance:
                    # keep track of stop time/frame for later
                    textEncodingTrial.tStop = t  # not accounting for scr refresh
                    textEncodingTrial.frameNStop = frameN  # exact frame index
                    win.timeOnFlip(textEncodingTrial, 'tStopRefresh')  # time at next scr refresh
                    textEncodingTrial.setAutoDraw(False)
            
            # *key_respEncoding* updates
            waitOnFlip = False
            if key_respEncoding.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
                # keep track of start time/frame for later
                key_respEncoding.frameNStart = frameN  # exact frame index
                key_respEncoding.tStart = t  # local t and not account for scr refresh
                key_respEncoding.tStartRefresh = tThisFlipGlobal  # on global time
                win.timeOnFlip(key_respEncoding, 'tStartRefresh')  # time at next scr refresh
                key_respEncoding.status = STARTED
                # keyboard checking is just starting
                waitOnFlip = True
                win.callOnFlip(key_respEncoding.clock.reset)  # t=0 on next screen flip
                win.callOnFlip(key_respEncoding.clearEvents, eventType='keyboard')  # clear events on next screen flip
            if key_respEncoding.status == STARTED:
                # is it time to stop? (based on global clock, using actual start)
                if tThisFlipGlobal > key_respEncoding.tStartRefresh + currentDifficultyLevel.duration-frameTolerance:
                    # keep track of stop time/frame for later
                    key_respEncoding.tStop = t  # not accounting for scr refresh
                    key_respEncoding.frameNStop = frameN  # exact frame index
                    win.timeOnFlip(key_respEncoding, 'tStopRefresh')  # time at next scr refresh
                    key_respEncoding.status = FINISHED
            if key_respEncoding.status == STARTED and not waitOnFlip:
                theseKeys = key_respEncoding.getKeys(keyList=['q'], waitRelease=False)
                _key_respEncoding_allKeys.extend(theseKeys)
                if len(_key_respEncoding_allKeys):
                    key_respEncoding.keys = _key_respEncoding_allKeys[-1].name  # just the last key pressed
                    key_respEncoding.rt = _key_respEncoding_allKeys[-1].rt
                    # a response ends the routine
                    continueRoutine = False
            
            # check for quit (typically the Esc key)
            if endExpNow or defaultKeyboard.getKeys(keyList=["escape"]):
                core.quit()
            
            # check if all components have finished
            if not continueRoutine:  # a component has requested a forced-end of Routine
                break
            continueRoutine = False  # will revert to True if at least one component still running
            for thisComponent in EncodingTrialComponents:
                if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
                    continueRoutine = True
                    break  # at least one component has not yet finished
            
            # refresh the screen
            if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
                win.flip()
        
        # -------Ending Routine "EncodingTrial"-------
        for thisComponent in EncodingTrialComponents:
            if hasattr(thisComponent, "setAutoDraw"):
                thisComponent.setAutoDraw(False)
        if key_respEncoding.keys != None:
            if 'q' in key_respEncoding.keys:
                trialsEncodingBlock.finished = 1
        
        currentEncodingWord += 1
        # the Routine "EncodingTrial" was not non-slip safe, so reset the non-slip timer
        routineTimer.reset()
    # completed currentDifficultyLevel.numEncoding repeats of 'trialsEncodingBlock'
    
    
    # ------Prepare to start Routine "EncodingEnd"-------
    continueRoutine = True
    # update component parameters for each repeat
    keyEncodingEnd.keys = []
    keyEncodingEnd.rt = []
    _keyEncodingEnd_allKeys = []
    # keep track of which components have finished
    EncodingEndComponents = [textEncodingEnd, keyEncodingEnd]
    for thisComponent in EncodingEndComponents:
        thisComponent.tStart = None
        thisComponent.tStop = None
        thisComponent.tStartRefresh = None
        thisComponent.tStopRefresh = None
        if hasattr(thisComponent, 'status'):
            thisComponent.status = NOT_STARTED
    # reset timers
    t = 0
    _timeToFirstFrame = win.getFutureFlipTime(clock="now")
    EncodingEndClock.reset(-_timeToFirstFrame)  # t0 is time of first possible flip
    frameN = -1
    
    # -------Run Routine "EncodingEnd"-------
    while continueRoutine:
        # get current time
        t = EncodingEndClock.getTime()
        tThisFlip = win.getFutureFlipTime(clock=EncodingEndClock)
        tThisFlipGlobal = win.getFutureFlipTime(clock=None)
        frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
        # update/draw components on each frame
        
        # *textEncodingEnd* updates
        if textEncodingEnd.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
            # keep track of start time/frame for later
            textEncodingEnd.frameNStart = frameN  # exact frame index
            textEncodingEnd.tStart = t  # local t and not account for scr refresh
            textEncodingEnd.tStartRefresh = tThisFlipGlobal  # on global time
            win.timeOnFlip(textEncodingEnd, 'tStartRefresh')  # time at next scr refresh
            textEncodingEnd.setAutoDraw(True)
        
        # *keyEncodingEnd* updates
        waitOnFlip = False
        if keyEncodingEnd.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
            # keep track of start time/frame for later
            keyEncodingEnd.frameNStart = frameN  # exact frame index
            keyEncodingEnd.tStart = t  # local t and not account for scr refresh
            keyEncodingEnd.tStartRefresh = tThisFlipGlobal  # on global time
            win.timeOnFlip(keyEncodingEnd, 'tStartRefresh')  # time at next scr refresh
            keyEncodingEnd.status = STARTED
            # keyboard checking is just starting
            waitOnFlip = True
            win.callOnFlip(keyEncodingEnd.clock.reset)  # t=0 on next screen flip
            win.callOnFlip(keyEncodingEnd.clearEvents, eventType='keyboard')  # clear events on next screen flip
        if keyEncodingEnd.status == STARTED and not waitOnFlip:
            theseKeys = keyEncodingEnd.getKeys(keyList=['space'], waitRelease=False)
            _keyEncodingEnd_allKeys.extend(theseKeys)
            if len(_keyEncodingEnd_allKeys):
                keyEncodingEnd.keys = _keyEncodingEnd_allKeys[-1].name  # just the last key pressed
                keyEncodingEnd.rt = _keyEncodingEnd_allKeys[-1].rt
                # a response ends the routine
                continueRoutine = False
        
        # check for quit (typically the Esc key)
        if endExpNow or defaultKeyboard.getKeys(keyList=["escape"]):
            core.quit()
        
        # check if all components have finished
        if not continueRoutine:  # a component has requested a forced-end of Routine
            break
        continueRoutine = False  # will revert to True if at least one component still running
        for thisComponent in EncodingEndComponents:
            if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
                continueRoutine = True
                break  # at least one component has not yet finished
        
        # refresh the screen
        if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
            win.flip()
    
    # -------Ending Routine "EncodingEnd"-------
    for thisComponent in EncodingEndComponents:
        if hasattr(thisComponent, "setAutoDraw"):
            thisComponent.setAutoDraw(False)
    # the Routine "EncodingEnd" was not non-slip safe, so reset the non-slip timer
    routineTimer.reset()
    
    # ------Prepare to start Routine "PreTestCode"-------
    continueRoutine = True
    # update component parameters for each repeat
    #create a list of the order in which to show study items
    studyOrder = list(range(numberTestTrials))
    
    #randomize the order in which study items are shown
    random.shuffle(studyOrder)
    # keep track of which components have finished
    PreTestCodeComponents = []
    for thisComponent in PreTestCodeComponents:
        thisComponent.tStart = None
        thisComponent.tStop = None
        thisComponent.tStartRefresh = None
        thisComponent.tStopRefresh = None
        if hasattr(thisComponent, 'status'):
            thisComponent.status = NOT_STARTED
    # reset timers
    t = 0
    _timeToFirstFrame = win.getFutureFlipTime(clock="now")
    PreTestCodeClock.reset(-_timeToFirstFrame)  # t0 is time of first possible flip
    frameN = -1
    
    # -------Run Routine "PreTestCode"-------
    while continueRoutine:
        # get current time
        t = PreTestCodeClock.getTime()
        tThisFlip = win.getFutureFlipTime(clock=PreTestCodeClock)
        tThisFlipGlobal = win.getFutureFlipTime(clock=None)
        frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
        # update/draw components on each frame
        
        # check for quit (typically the Esc key)
        if endExpNow or defaultKeyboard.getKeys(keyList=["escape"]):
            core.quit()
        
        # check if all components have finished
        if not continueRoutine:  # a component has requested a forced-end of Routine
            break
        continueRoutine = False  # will revert to True if at least one component still running
        for thisComponent in PreTestCodeComponents:
            if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
                continueRoutine = True
                break  # at least one component has not yet finished
        
        # refresh the screen
        if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
            win.flip()
    
    # -------Ending Routine "PreTestCode"-------
    for thisComponent in PreTestCodeComponents:
        if hasattr(thisComponent, "setAutoDraw"):
            thisComponent.setAutoDraw(False)
    # the Routine "PreTestCode" was not non-slip safe, so reset the non-slip timer
    routineTimer.reset()
    
    # ------Prepare to start Routine "TestingInstruct"-------
    continueRoutine = True
    # update component parameters for each repeat
    keyTestingInstruct.keys = []
    keyTestingInstruct.rt = []
    _keyTestingInstruct_allKeys = []
    # keep track of which components have finished
    TestingInstructComponents = [textTestingInstruct, keyTestingInstruct, imageFKey, imageJKey, textTestingInstructSpace, textTestingInstructF, textTestingInstructJ, p_port_init]
    for thisComponent in TestingInstructComponents:
        thisComponent.tStart = None
        thisComponent.tStop = None
        thisComponent.tStartRefresh = None
        thisComponent.tStopRefresh = None
        if hasattr(thisComponent, 'status'):
            thisComponent.status = NOT_STARTED
    # reset timers
    t = 0
    _timeToFirstFrame = win.getFutureFlipTime(clock="now")
    TestingInstructClock.reset(-_timeToFirstFrame)  # t0 is time of first possible flip
    frameN = -1
    
    # -------Run Routine "TestingInstruct"-------
    while continueRoutine:
        # get current time
        t = TestingInstructClock.getTime()
        tThisFlip = win.getFutureFlipTime(clock=TestingInstructClock)
        tThisFlipGlobal = win.getFutureFlipTime(clock=None)
        frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
        # update/draw components on each frame
        
        # *textTestingInstruct* updates
        if textTestingInstruct.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
            # keep track of start time/frame for later
            textTestingInstruct.frameNStart = frameN  # exact frame index
            textTestingInstruct.tStart = t  # local t and not account for scr refresh
            textTestingInstruct.tStartRefresh = tThisFlipGlobal  # on global time
            win.timeOnFlip(textTestingInstruct, 'tStartRefresh')  # time at next scr refresh
            textTestingInstruct.setAutoDraw(True)
        
        # *keyTestingInstruct* updates
        waitOnFlip = False
        if keyTestingInstruct.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
            # keep track of start time/frame for later
            keyTestingInstruct.frameNStart = frameN  # exact frame index
            keyTestingInstruct.tStart = t  # local t and not account for scr refresh
            keyTestingInstruct.tStartRefresh = tThisFlipGlobal  # on global time
            win.timeOnFlip(keyTestingInstruct, 'tStartRefresh')  # time at next scr refresh
            keyTestingInstruct.status = STARTED
            # keyboard checking is just starting
            waitOnFlip = True
            win.callOnFlip(keyTestingInstruct.clock.reset)  # t=0 on next screen flip
            win.callOnFlip(keyTestingInstruct.clearEvents, eventType='keyboard')  # clear events on next screen flip
        if keyTestingInstruct.status == STARTED and not waitOnFlip:
            theseKeys = keyTestingInstruct.getKeys(keyList=['space'], waitRelease=False)
            _keyTestingInstruct_allKeys.extend(theseKeys)
            if len(_keyTestingInstruct_allKeys):
                keyTestingInstruct.keys = _keyTestingInstruct_allKeys[-1].name  # just the last key pressed
                keyTestingInstruct.rt = _keyTestingInstruct_allKeys[-1].rt
                # a response ends the routine
                continueRoutine = False
        
        # *imageFKey* updates
        if imageFKey.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
            # keep track of start time/frame for later
            imageFKey.frameNStart = frameN  # exact frame index
            imageFKey.tStart = t  # local t and not account for scr refresh
            imageFKey.tStartRefresh = tThisFlipGlobal  # on global time
            win.timeOnFlip(imageFKey, 'tStartRefresh')  # time at next scr refresh
            imageFKey.setAutoDraw(True)
        
        # *imageJKey* updates
        if imageJKey.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
            # keep track of start time/frame for later
            imageJKey.frameNStart = frameN  # exact frame index
            imageJKey.tStart = t  # local t and not account for scr refresh
            imageJKey.tStartRefresh = tThisFlipGlobal  # on global time
            win.timeOnFlip(imageJKey, 'tStartRefresh')  # time at next scr refresh
            imageJKey.setAutoDraw(True)
        
        # *textTestingInstructSpace* updates
        if textTestingInstructSpace.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
            # keep track of start time/frame for later
            textTestingInstructSpace.frameNStart = frameN  # exact frame index
            textTestingInstructSpace.tStart = t  # local t and not account for scr refresh
            textTestingInstructSpace.tStartRefresh = tThisFlipGlobal  # on global time
            win.timeOnFlip(textTestingInstructSpace, 'tStartRefresh')  # time at next scr refresh
            textTestingInstructSpace.setAutoDraw(True)
        
        # *textTestingInstructF* updates
        if textTestingInstructF.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
            # keep track of start time/frame for later
            textTestingInstructF.frameNStart = frameN  # exact frame index
            textTestingInstructF.tStart = t  # local t and not account for scr refresh
            textTestingInstructF.tStartRefresh = tThisFlipGlobal  # on global time
            win.timeOnFlip(textTestingInstructF, 'tStartRefresh')  # time at next scr refresh
            textTestingInstructF.setAutoDraw(True)
        
        # *textTestingInstructJ* updates
        if textTestingInstructJ.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
            # keep track of start time/frame for later
            textTestingInstructJ.frameNStart = frameN  # exact frame index
            textTestingInstructJ.tStart = t  # local t and not account for scr refresh
            textTestingInstructJ.tStartRefresh = tThisFlipGlobal  # on global time
            win.timeOnFlip(textTestingInstructJ, 'tStartRefresh')  # time at next scr refresh
            textTestingInstructJ.setAutoDraw(True)
        # *p_port_init* updates
        if p_port_init.status == NOT_STARTED and tThisFlip >= 0-frameTolerance:
            # keep track of start time/frame for later
            p_port_init.frameNStart = frameN  # exact frame index
            p_port_init.tStart = t  # local t and not account for scr refresh
            p_port_init.tStartRefresh = tThisFlipGlobal  # on global time
            win.timeOnFlip(p_port_init, 'tStartRefresh')  # time at next scr refresh
            p_port_init.status = STARTED
            win.callOnFlip(p_port_init.setData, int(200))
        if p_port_init.status == STARTED:
            # is it time to stop? (based on global clock, using actual start)
            if tThisFlipGlobal > p_port_init.tStartRefresh + 0.1-frameTolerance:
                # keep track of stop time/frame for later
                p_port_init.tStop = t  # not accounting for scr refresh
                p_port_init.frameNStop = frameN  # exact frame index
                win.timeOnFlip(p_port_init, 'tStopRefresh')  # time at next scr refresh
                p_port_init.status = FINISHED
                win.callOnFlip(p_port_init.setData, int(0))
        
        # check for quit (typically the Esc key)
        if endExpNow or defaultKeyboard.getKeys(keyList=["escape"]):
            core.quit()
        
        # check if all components have finished
        if not continueRoutine:  # a component has requested a forced-end of Routine
            break
        continueRoutine = False  # will revert to True if at least one component still running
        for thisComponent in TestingInstructComponents:
            if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
                continueRoutine = True
                break  # at least one component has not yet finished
        
        # refresh the screen
        if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
            win.flip()
    
    # -------Ending Routine "TestingInstruct"-------
    for thisComponent in TestingInstructComponents:
        if hasattr(thisComponent, "setAutoDraw"):
            thisComponent.setAutoDraw(False)
    if p_port_init.status == STARTED:
        win.callOnFlip(p_port_init.setData, int(0))
    trialsExperimentBlock.addData('p_port_init.started', p_port_init.tStartRefresh)
    trialsExperimentBlock.addData('p_port_init.stopped', p_port_init.tStopRefresh)
    # the Routine "TestingInstruct" was not non-slip safe, so reset the non-slip timer
    routineTimer.reset()
    
    # set up handler to look after randomisation of conditions etc
    trialsTestingBlock = data.TrialHandler(nReps=numberTestTrials, method='random', 
        extraInfo=expInfo, originPath=-1,
        trialList=[None],
        seed=None, name='trialsTestingBlock')
    thisExp.addLoop(trialsTestingBlock)  # add the loop to the experiment
    thisTrialsTestingBlock = trialsTestingBlock.trialList[0]  # so we can initialise stimuli with some values
    # abbreviate parameter names if possible (e.g. rgb = thisTrialsTestingBlock.rgb)
    if thisTrialsTestingBlock != None:
        for paramName in thisTrialsTestingBlock:
            exec('{} = thisTrialsTestingBlock[paramName]'.format(paramName))
    
    for thisTrialsTestingBlock in trialsTestingBlock:
        currentLoop = trialsTestingBlock
        # abbreviate parameter names if possible (e.g. rgb = thisTrialsTestingBlock.rgb)
        if thisTrialsTestingBlock != None:
            for paramName in thisTrialsTestingBlock:
                exec('{} = thisTrialsTestingBlock[paramName]'.format(paramName))
        
        # ------Prepare to start Routine "TestInitCode"-------
        continueRoutine = True
        # update component parameters for each repeat
        #assign the study item
        testWord = wordItem[studyOrder[currentTestWord]]
        testOldNew = oldNew[studyOrder[currentTestWord]]
        testCorrect = correctAnswer[studyOrder[currentTestWord]]
        testCorrectTrigger = correctTrigger[studyOrder[currentTestWord]]
        
        #log study information to data file
        thisExp.addData('WordItem', testWord)
        thisExp.addData('OldNew', testOldNew)
        # keep track of which components have finished
        TestInitCodeComponents = []
        for thisComponent in TestInitCodeComponents:
            thisComponent.tStart = None
            thisComponent.tStop = None
            thisComponent.tStartRefresh = None
            thisComponent.tStopRefresh = None
            if hasattr(thisComponent, 'status'):
                thisComponent.status = NOT_STARTED
        # reset timers
        t = 0
        _timeToFirstFrame = win.getFutureFlipTime(clock="now")
        TestInitCodeClock.reset(-_timeToFirstFrame)  # t0 is time of first possible flip
        frameN = -1
        
        # -------Run Routine "TestInitCode"-------
        while continueRoutine:
            # get current time
            t = TestInitCodeClock.getTime()
            tThisFlip = win.getFutureFlipTime(clock=TestInitCodeClock)
            tThisFlipGlobal = win.getFutureFlipTime(clock=None)
            frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
            # update/draw components on each frame
            
            # check for quit (typically the Esc key)
            if endExpNow or defaultKeyboard.getKeys(keyList=["escape"]):
                core.quit()
            
            # check if all components have finished
            if not continueRoutine:  # a component has requested a forced-end of Routine
                break
            continueRoutine = False  # will revert to True if at least one component still running
            for thisComponent in TestInitCodeComponents:
                if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
                    continueRoutine = True
                    break  # at least one component has not yet finished
            
            # refresh the screen
            if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
                win.flip()
        
        # -------Ending Routine "TestInitCode"-------
        for thisComponent in TestInitCodeComponents:
            if hasattr(thisComponent, "setAutoDraw"):
                thisComponent.setAutoDraw(False)
        # the Routine "TestInitCode" was not non-slip safe, so reset the non-slip timer
        routineTimer.reset()
        
        # ------Prepare to start Routine "Fixation"-------
        continueRoutine = True
        # update component parameters for each repeat
        jitterRange = np.arange(0.9, 1.2, 0.1)
        shuffle(jitterRange)
        jitter = jitterRange[0]
        # keep track of which components have finished
        FixationComponents = [textFixation]
        for thisComponent in FixationComponents:
            thisComponent.tStart = None
            thisComponent.tStop = None
            thisComponent.tStartRefresh = None
            thisComponent.tStopRefresh = None
            if hasattr(thisComponent, 'status'):
                thisComponent.status = NOT_STARTED
        # reset timers
        t = 0
        _timeToFirstFrame = win.getFutureFlipTime(clock="now")
        FixationClock.reset(-_timeToFirstFrame)  # t0 is time of first possible flip
        frameN = -1
        
        # -------Run Routine "Fixation"-------
        while continueRoutine:
            # get current time
            t = FixationClock.getTime()
            tThisFlip = win.getFutureFlipTime(clock=FixationClock)
            tThisFlipGlobal = win.getFutureFlipTime(clock=None)
            frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
            # update/draw components on each frame
            
            # *textFixation* updates
            if textFixation.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
                # keep track of start time/frame for later
                textFixation.frameNStart = frameN  # exact frame index
                textFixation.tStart = t  # local t and not account for scr refresh
                textFixation.tStartRefresh = tThisFlipGlobal  # on global time
                win.timeOnFlip(textFixation, 'tStartRefresh')  # time at next scr refresh
                textFixation.setAutoDraw(True)
            if textFixation.status == STARTED:
                # is it time to stop? (based on global clock, using actual start)
                if tThisFlipGlobal > textFixation.tStartRefresh + jitter-frameTolerance:
                    # keep track of stop time/frame for later
                    textFixation.tStop = t  # not accounting for scr refresh
                    textFixation.frameNStop = frameN  # exact frame index
                    win.timeOnFlip(textFixation, 'tStopRefresh')  # time at next scr refresh
                    textFixation.setAutoDraw(False)
            
            # check for quit (typically the Esc key)
            if endExpNow or defaultKeyboard.getKeys(keyList=["escape"]):
                core.quit()
            
            # check if all components have finished
            if not continueRoutine:  # a component has requested a forced-end of Routine
                break
            continueRoutine = False  # will revert to True if at least one component still running
            for thisComponent in FixationComponents:
                if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
                    continueRoutine = True
                    break  # at least one component has not yet finished
            
            # refresh the screen
            if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
                win.flip()
        
        # -------Ending Routine "Fixation"-------
        for thisComponent in FixationComponents:
            if hasattr(thisComponent, "setAutoDraw"):
                thisComponent.setAutoDraw(False)
        # the Routine "Fixation" was not non-slip safe, so reset the non-slip timer
        routineTimer.reset()
        
        # ------Prepare to start Routine "TestingTrial"-------
        continueRoutine = True
        # update component parameters for each repeat
        textTestingTrial.setText(testWord)
        key_respTrial.keys = []
        key_respTrial.rt = []
        _key_respTrial_allKeys = []
        countedKeys = 0
        # keep track of which components have finished
        TestingTrialComponents = [textTestingTrial, key_respTrial, p_port_trial_new, p_port_trial_old, p_port_incorrect]
        for thisComponent in TestingTrialComponents:
            thisComponent.tStart = None
            thisComponent.tStop = None
            thisComponent.tStartRefresh = None
            thisComponent.tStopRefresh = None
            if hasattr(thisComponent, 'status'):
                thisComponent.status = NOT_STARTED
        # reset timers
        t = 0
        _timeToFirstFrame = win.getFutureFlipTime(clock="now")
        TestingTrialClock.reset(-_timeToFirstFrame)  # t0 is time of first possible flip
        frameN = -1
        
        # -------Run Routine "TestingTrial"-------
        while continueRoutine:
            # get current time
            t = TestingTrialClock.getTime()
            tThisFlip = win.getFutureFlipTime(clock=TestingTrialClock)
            tThisFlipGlobal = win.getFutureFlipTime(clock=None)
            frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
            # update/draw components on each frame
            
            # *textTestingTrial* updates
            if textTestingTrial.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
                # keep track of start time/frame for later
                textTestingTrial.frameNStart = frameN  # exact frame index
                textTestingTrial.tStart = t  # local t and not account for scr refresh
                textTestingTrial.tStartRefresh = tThisFlipGlobal  # on global time
                win.timeOnFlip(textTestingTrial, 'tStartRefresh')  # time at next scr refresh
                textTestingTrial.setAutoDraw(True)
            if textTestingTrial.status == STARTED:
                # is it time to stop? (based on global clock, using actual start)
                if tThisFlipGlobal > textTestingTrial.tStartRefresh + 1.3-frameTolerance:
                    # keep track of stop time/frame for later
                    textTestingTrial.tStop = t  # not accounting for scr refresh
                    textTestingTrial.frameNStop = frameN  # exact frame index
                    win.timeOnFlip(textTestingTrial, 'tStopRefresh')  # time at next scr refresh
                    textTestingTrial.setAutoDraw(False)
            
            # *key_respTrial* updates
            waitOnFlip = False
            if key_respTrial.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
                # keep track of start time/frame for later
                key_respTrial.frameNStart = frameN  # exact frame index
                key_respTrial.tStart = t  # local t and not account for scr refresh
                key_respTrial.tStartRefresh = tThisFlipGlobal  # on global time
                win.timeOnFlip(key_respTrial, 'tStartRefresh')  # time at next scr refresh
                key_respTrial.status = STARTED
                # keyboard checking is just starting
                waitOnFlip = True
                win.callOnFlip(key_respTrial.clock.reset)  # t=0 on next screen flip
                win.callOnFlip(key_respTrial.clearEvents, eventType='keyboard')  # clear events on next screen flip
            if key_respTrial.status == STARTED:
                # is it time to stop? (based on global clock, using actual start)
                if tThisFlipGlobal > key_respTrial.tStartRefresh + 1.3-frameTolerance:
                    # keep track of stop time/frame for later
                    key_respTrial.tStop = t  # not accounting for scr refresh
                    key_respTrial.frameNStop = frameN  # exact frame index
                    win.timeOnFlip(key_respTrial, 'tStopRefresh')  # time at next scr refresh
                    key_respTrial.status = FINISHED
            if key_respTrial.status == STARTED and not waitOnFlip:
                theseKeys = key_respTrial.getKeys(keyList=['f','j','q'], waitRelease=False)
                _key_respTrial_allKeys.extend(theseKeys)
                if len(_key_respTrial_allKeys):
                    key_respTrial.keys = _key_respTrial_allKeys[0].name  # just the first key pressed
                    key_respTrial.rt = _key_respTrial_allKeys[0].rt
                    # was this correct?
                    if (key_respTrial.keys == str(testCorrect)) or (key_respTrial.keys == testCorrect):
                        key_respTrial.corr = 1
                    else:
                        key_respTrial.corr = 0
                    # a response ends the routine
                    continueRoutine = False
            if len(key_respTrial.keys) > countedKeys:
                countedKeys += 1
            # *p_port_trial_new* updates
            if p_port_trial_new.status == NOT_STARTED and tThisFlip >= 0-frameTolerance:
                # keep track of start time/frame for later
                p_port_trial_new.frameNStart = frameN  # exact frame index
                p_port_trial_new.tStart = t  # local t and not account for scr refresh
                p_port_trial_new.tStartRefresh = tThisFlipGlobal  # on global time
                win.timeOnFlip(p_port_trial_new, 'tStartRefresh')  # time at next scr refresh
                p_port_trial_new.status = STARTED
                win.callOnFlip(p_port_trial_new.setData, int(testCorrectTrigger))
            if p_port_trial_new.status == STARTED:
                if frameN >= (p_port_trial_new.frameNStart + 0.1):
                    # keep track of stop time/frame for later
                    p_port_trial_new.tStop = t  # not accounting for scr refresh
                    p_port_trial_new.frameNStop = frameN  # exact frame index
                    win.timeOnFlip(p_port_trial_new, 'tStopRefresh')  # time at next scr refresh
                    p_port_trial_new.status = FINISHED
                    win.callOnFlip(p_port_trial_new.setData, int(0))
            # *p_port_trial_old* updates
            if p_port_trial_old.status == NOT_STARTED and 0:
                # keep track of start time/frame for later
                p_port_trial_old.frameNStart = frameN  # exact frame index
                p_port_trial_old.tStart = t  # local t and not account for scr refresh
                p_port_trial_old.tStartRefresh = tThisFlipGlobal  # on global time
                win.timeOnFlip(p_port_trial_old, 'tStartRefresh')  # time at next scr refresh
                p_port_trial_old.status = STARTED
                win.callOnFlip(p_port_trial_old.setData, int(testCorrectTrigger))
            if p_port_trial_old.status == STARTED:
                # is it time to stop? (based on global clock, using actual start)
                if tThisFlipGlobal > p_port_trial_old.tStartRefresh + 0.1-frameTolerance:
                    # keep track of stop time/frame for later
                    p_port_trial_old.tStop = t  # not accounting for scr refresh
                    p_port_trial_old.frameNStop = frameN  # exact frame index
                    win.timeOnFlip(p_port_trial_old, 'tStopRefresh')  # time at next scr refresh
                    p_port_trial_old.status = FINISHED
                    win.callOnFlip(p_port_trial_old.setData, int(0))
            # *p_port_incorrect* updates
            if p_port_incorrect.status == NOT_STARTED and countedKeys > 0:
                # keep track of start time/frame for later
                p_port_incorrect.frameNStart = frameN  # exact frame index
                p_port_incorrect.tStart = t  # local t and not account for scr refresh
                p_port_incorrect.tStartRefresh = tThisFlipGlobal  # on global time
                win.timeOnFlip(p_port_incorrect, 'tStartRefresh')  # time at next scr refresh
                p_port_incorrect.status = STARTED
                win.callOnFlip(p_port_incorrect.setData, int(21))
            if p_port_incorrect.status == STARTED:
                # is it time to stop? (based on global clock, using actual start)
                if tThisFlipGlobal > p_port_incorrect.tStartRefresh + 0.1-frameTolerance:
                    # keep track of stop time/frame for later
                    p_port_incorrect.tStop = t  # not accounting for scr refresh
                    p_port_incorrect.frameNStop = frameN  # exact frame index
                    win.timeOnFlip(p_port_incorrect, 'tStopRefresh')  # time at next scr refresh
                    p_port_incorrect.status = FINISHED
                    win.callOnFlip(p_port_incorrect.setData, int(0))
            
            # check for quit (typically the Esc key)
            if endExpNow or defaultKeyboard.getKeys(keyList=["escape"]):
                core.quit()
            
            # check if all components have finished
            if not continueRoutine:  # a component has requested a forced-end of Routine
                break
            continueRoutine = False  # will revert to True if at least one component still running
            for thisComponent in TestingTrialComponents:
                if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
                    continueRoutine = True
                    break  # at least one component has not yet finished
            
            # refresh the screen
            if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
                win.flip()
        
        # -------Ending Routine "TestingTrial"-------
        for thisComponent in TestingTrialComponents:
            if hasattr(thisComponent, "setAutoDraw"):
                thisComponent.setAutoDraw(False)
        trialsTestingBlock.addData('textTestingTrial.started', textTestingTrial.tStartRefresh)
        trialsTestingBlock.addData('textTestingTrial.stopped', textTestingTrial.tStopRefresh)
        # check responses
        if key_respTrial.keys in ['', [], None]:  # No response was made
            key_respTrial.keys = None
            # was no response the correct answer?!
            if str(testCorrect).lower() == 'none':
               key_respTrial.corr = 1;  # correct non-response
            else:
               key_respTrial.corr = 0;  # failed to respond (incorrectly)
        # store data for trialsTestingBlock (TrialHandler)
        trialsTestingBlock.addData('key_respTrial.keys',key_respTrial.keys)
        trialsTestingBlock.addData('key_respTrial.corr', key_respTrial.corr)
        if key_respTrial.keys != None:  # we had a response
            trialsTestingBlock.addData('key_respTrial.rt', key_respTrial.rt)
        trialsTestingBlock.addData('key_respTrial.started', key_respTrial.tStartRefresh)
        trialsTestingBlock.addData('key_respTrial.stopped', key_respTrial.tStopRefresh)
        if key_respTrial.keys == None or 'q' in key_respTrial.keys:
            unansweredCounter += 1
            answered = False
        else:
            answeredCounter += 1
            answered = True
        
        if key_respTrial.corr == 1:
            correctCounter += 1
            if testOldNew == "new" and answered:
                correctRejectionCounter += 1
            if testOldNew == "old" and answered:
                hitCounter += 1
        else:
            errorCounterCurrentBlock += 1
            errorCounter += 1
            if testOldNew == "new" and answered:
                falseAlarmCounter += 1
            if testOldNew == "old" and answered:
                missCounter += 1
        if key_respTrial.keys != None:
            if 'q' in key_respTrial.keys:
                trialsTestingBlock.finished = 1
        #Trigger code for button press
        # 21 for correct press, 22 for incorrect
        
        correctParallelTrigger = 22
        
        if key_respTrial.corr == 1:
            correctParallelTrigger = 21
        if p_port_trial_new.status == STARTED:
            win.callOnFlip(p_port_trial_new.setData, int(0))
        trialsTestingBlock.addData('p_port_trial_new.started', p_port_trial_new.tStartRefresh)
        trialsTestingBlock.addData('p_port_trial_new.stopped', p_port_trial_new.tStopRefresh)
        if p_port_trial_old.status == STARTED:
            win.callOnFlip(p_port_trial_old.setData, int(0))
        trialsTestingBlock.addData('p_port_trial_old.started', p_port_trial_old.tStartRefresh)
        trialsTestingBlock.addData('p_port_trial_old.stopped', p_port_trial_old.tStopRefresh)
        if p_port_incorrect.status == STARTED:
            win.callOnFlip(p_port_incorrect.setData, int(0))
        trialsTestingBlock.addData('p_port_incorrect.started', p_port_incorrect.tStartRefresh)
        trialsTestingBlock.addData('p_port_incorrect.stopped', p_port_incorrect.tStopRefresh)
        # the Routine "TestingTrial" was not non-slip safe, so reset the non-slip timer
        routineTimer.reset()
        
        # ------Prepare to start Routine "CorrectnessSelect"-------
        continueRoutine = True
        # update component parameters for each repeat
        #correctParallelTrigger = 80
        
        if key_respTrial.corr == 1:
            nRepsCorrect = 1
            nRepsIncorrect = 0
            #correctParallelTrigger = 21
        else:
            nRepsCorrect = 0
            nRepsIncorrect = 1
            #correctParallelTrigger = 22
        # keep track of which components have finished
        CorrectnessSelectComponents = []
        for thisComponent in CorrectnessSelectComponents:
            thisComponent.tStart = None
            thisComponent.tStop = None
            thisComponent.tStartRefresh = None
            thisComponent.tStopRefresh = None
            if hasattr(thisComponent, 'status'):
                thisComponent.status = NOT_STARTED
        # reset timers
        t = 0
        _timeToFirstFrame = win.getFutureFlipTime(clock="now")
        CorrectnessSelectClock.reset(-_timeToFirstFrame)  # t0 is time of first possible flip
        frameN = -1
        
        # -------Run Routine "CorrectnessSelect"-------
        while continueRoutine:
            # get current time
            t = CorrectnessSelectClock.getTime()
            tThisFlip = win.getFutureFlipTime(clock=CorrectnessSelectClock)
            tThisFlipGlobal = win.getFutureFlipTime(clock=None)
            frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
            # update/draw components on each frame
            
            # check for quit (typically the Esc key)
            if endExpNow or defaultKeyboard.getKeys(keyList=["escape"]):
                core.quit()
            
            # check if all components have finished
            if not continueRoutine:  # a component has requested a forced-end of Routine
                break
            continueRoutine = False  # will revert to True if at least one component still running
            for thisComponent in CorrectnessSelectComponents:
                if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
                    continueRoutine = True
                    break  # at least one component has not yet finished
            
            # refresh the screen
            if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
                win.flip()
        
        # -------Ending Routine "CorrectnessSelect"-------
        for thisComponent in CorrectnessSelectComponents:
            if hasattr(thisComponent, "setAutoDraw"):
                thisComponent.setAutoDraw(False)
        # the Routine "CorrectnessSelect" was not non-slip safe, so reset the non-slip timer
        routineTimer.reset()
        
        # ------Prepare to start Routine "Fixation"-------
        continueRoutine = True
        # update component parameters for each repeat
        jitterRange = np.arange(0.9, 1.2, 0.1)
        shuffle(jitterRange)
        jitter = jitterRange[0]
        # keep track of which components have finished
        FixationComponents = [textFixation]
        for thisComponent in FixationComponents:
            thisComponent.tStart = None
            thisComponent.tStop = None
            thisComponent.tStartRefresh = None
            thisComponent.tStopRefresh = None
            if hasattr(thisComponent, 'status'):
                thisComponent.status = NOT_STARTED
        # reset timers
        t = 0
        _timeToFirstFrame = win.getFutureFlipTime(clock="now")
        FixationClock.reset(-_timeToFirstFrame)  # t0 is time of first possible flip
        frameN = -1
        
        # -------Run Routine "Fixation"-------
        while continueRoutine:
            # get current time
            t = FixationClock.getTime()
            tThisFlip = win.getFutureFlipTime(clock=FixationClock)
            tThisFlipGlobal = win.getFutureFlipTime(clock=None)
            frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
            # update/draw components on each frame
            
            # *textFixation* updates
            if textFixation.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
                # keep track of start time/frame for later
                textFixation.frameNStart = frameN  # exact frame index
                textFixation.tStart = t  # local t and not account for scr refresh
                textFixation.tStartRefresh = tThisFlipGlobal  # on global time
                win.timeOnFlip(textFixation, 'tStartRefresh')  # time at next scr refresh
                textFixation.setAutoDraw(True)
            if textFixation.status == STARTED:
                # is it time to stop? (based on global clock, using actual start)
                if tThisFlipGlobal > textFixation.tStartRefresh + jitter-frameTolerance:
                    # keep track of stop time/frame for later
                    textFixation.tStop = t  # not accounting for scr refresh
                    textFixation.frameNStop = frameN  # exact frame index
                    win.timeOnFlip(textFixation, 'tStopRefresh')  # time at next scr refresh
                    textFixation.setAutoDraw(False)
            
            # check for quit (typically the Esc key)
            if endExpNow or defaultKeyboard.getKeys(keyList=["escape"]):
                core.quit()
            
            # check if all components have finished
            if not continueRoutine:  # a component has requested a forced-end of Routine
                break
            continueRoutine = False  # will revert to True if at least one component still running
            for thisComponent in FixationComponents:
                if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
                    continueRoutine = True
                    break  # at least one component has not yet finished
            
            # refresh the screen
            if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
                win.flip()
        
        # -------Ending Routine "Fixation"-------
        for thisComponent in FixationComponents:
            if hasattr(thisComponent, "setAutoDraw"):
                thisComponent.setAutoDraw(False)
        # the Routine "Fixation" was not non-slip safe, so reset the non-slip timer
        routineTimer.reset()
        
        # ------Prepare to start Routine "ConfidenceTrial"-------
        continueRoutine = True
        routineTimer.add(1.500000)
        # update component parameters for each repeat
        key_respConfidence.keys = []
        key_respConfidence.rt = []
        _key_respConfidence_allKeys = []
        # keep track of which components have finished
        ConfidenceTrialComponents = [textConfidenceTrial, textTestingConfidenceF, textTestingConfidenceJ, key_respConfidence]
        for thisComponent in ConfidenceTrialComponents:
            thisComponent.tStart = None
            thisComponent.tStop = None
            thisComponent.tStartRefresh = None
            thisComponent.tStopRefresh = None
            if hasattr(thisComponent, 'status'):
                thisComponent.status = NOT_STARTED
        # reset timers
        t = 0
        _timeToFirstFrame = win.getFutureFlipTime(clock="now")
        ConfidenceTrialClock.reset(-_timeToFirstFrame)  # t0 is time of first possible flip
        frameN = -1
        
        # -------Run Routine "ConfidenceTrial"-------
        while continueRoutine and routineTimer.getTime() > 0:
            # get current time
            t = ConfidenceTrialClock.getTime()
            tThisFlip = win.getFutureFlipTime(clock=ConfidenceTrialClock)
            tThisFlipGlobal = win.getFutureFlipTime(clock=None)
            frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
            # update/draw components on each frame
            
            # *textConfidenceTrial* updates
            if textConfidenceTrial.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
                # keep track of start time/frame for later
                textConfidenceTrial.frameNStart = frameN  # exact frame index
                textConfidenceTrial.tStart = t  # local t and not account for scr refresh
                textConfidenceTrial.tStartRefresh = tThisFlipGlobal  # on global time
                win.timeOnFlip(textConfidenceTrial, 'tStartRefresh')  # time at next scr refresh
                textConfidenceTrial.setAutoDraw(True)
            if textConfidenceTrial.status == STARTED:
                # is it time to stop? (based on global clock, using actual start)
                if tThisFlipGlobal > textConfidenceTrial.tStartRefresh + 1.5-frameTolerance:
                    # keep track of stop time/frame for later
                    textConfidenceTrial.tStop = t  # not accounting for scr refresh
                    textConfidenceTrial.frameNStop = frameN  # exact frame index
                    win.timeOnFlip(textConfidenceTrial, 'tStopRefresh')  # time at next scr refresh
                    textConfidenceTrial.setAutoDraw(False)
            
            # *textTestingConfidenceF* updates
            if textTestingConfidenceF.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
                # keep track of start time/frame for later
                textTestingConfidenceF.frameNStart = frameN  # exact frame index
                textTestingConfidenceF.tStart = t  # local t and not account for scr refresh
                textTestingConfidenceF.tStartRefresh = tThisFlipGlobal  # on global time
                win.timeOnFlip(textTestingConfidenceF, 'tStartRefresh')  # time at next scr refresh
                textTestingConfidenceF.setAutoDraw(True)
            if textTestingConfidenceF.status == STARTED:
                # is it time to stop? (based on global clock, using actual start)
                if tThisFlipGlobal > textTestingConfidenceF.tStartRefresh + 1.5-frameTolerance:
                    # keep track of stop time/frame for later
                    textTestingConfidenceF.tStop = t  # not accounting for scr refresh
                    textTestingConfidenceF.frameNStop = frameN  # exact frame index
                    win.timeOnFlip(textTestingConfidenceF, 'tStopRefresh')  # time at next scr refresh
                    textTestingConfidenceF.setAutoDraw(False)
            
            # *textTestingConfidenceJ* updates
            if textTestingConfidenceJ.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
                # keep track of start time/frame for later
                textTestingConfidenceJ.frameNStart = frameN  # exact frame index
                textTestingConfidenceJ.tStart = t  # local t and not account for scr refresh
                textTestingConfidenceJ.tStartRefresh = tThisFlipGlobal  # on global time
                win.timeOnFlip(textTestingConfidenceJ, 'tStartRefresh')  # time at next scr refresh
                textTestingConfidenceJ.setAutoDraw(True)
            if textTestingConfidenceJ.status == STARTED:
                # is it time to stop? (based on global clock, using actual start)
                if tThisFlipGlobal > textTestingConfidenceJ.tStartRefresh + 1.5-frameTolerance:
                    # keep track of stop time/frame for later
                    textTestingConfidenceJ.tStop = t  # not accounting for scr refresh
                    textTestingConfidenceJ.frameNStop = frameN  # exact frame index
                    win.timeOnFlip(textTestingConfidenceJ, 'tStopRefresh')  # time at next scr refresh
                    textTestingConfidenceJ.setAutoDraw(False)
            
            # *key_respConfidence* updates
            waitOnFlip = False
            if key_respConfidence.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
                # keep track of start time/frame for later
                key_respConfidence.frameNStart = frameN  # exact frame index
                key_respConfidence.tStart = t  # local t and not account for scr refresh
                key_respConfidence.tStartRefresh = tThisFlipGlobal  # on global time
                win.timeOnFlip(key_respConfidence, 'tStartRefresh')  # time at next scr refresh
                key_respConfidence.status = STARTED
                # keyboard checking is just starting
                waitOnFlip = True
                win.callOnFlip(key_respConfidence.clock.reset)  # t=0 on next screen flip
                win.callOnFlip(key_respConfidence.clearEvents, eventType='keyboard')  # clear events on next screen flip
            if key_respConfidence.status == STARTED:
                # is it time to stop? (based on global clock, using actual start)
                if tThisFlipGlobal > key_respConfidence.tStartRefresh + 1.5-frameTolerance:
                    # keep track of stop time/frame for later
                    key_respConfidence.tStop = t  # not accounting for scr refresh
                    key_respConfidence.frameNStop = frameN  # exact frame index
                    win.timeOnFlip(key_respConfidence, 'tStopRefresh')  # time at next scr refresh
                    key_respConfidence.status = FINISHED
            if key_respConfidence.status == STARTED and not waitOnFlip:
                theseKeys = key_respConfidence.getKeys(keyList=['f','j'], waitRelease=False)
                _key_respConfidence_allKeys.extend(theseKeys)
                if len(_key_respConfidence_allKeys):
                    key_respConfidence.keys = _key_respConfidence_allKeys[-1].name  # just the last key pressed
                    key_respConfidence.rt = _key_respConfidence_allKeys[-1].rt
                    # a response ends the routine
                    continueRoutine = False
            
            # check for quit (typically the Esc key)
            if endExpNow or defaultKeyboard.getKeys(keyList=["escape"]):
                core.quit()
            
            # check if all components have finished
            if not continueRoutine:  # a component has requested a forced-end of Routine
                break
            continueRoutine = False  # will revert to True if at least one component still running
            for thisComponent in ConfidenceTrialComponents:
                if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
                    continueRoutine = True
                    break  # at least one component has not yet finished
            
            # refresh the screen
            if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
                win.flip()
        
        # -------Ending Routine "ConfidenceTrial"-------
        for thisComponent in ConfidenceTrialComponents:
            if hasattr(thisComponent, "setAutoDraw"):
                thisComponent.setAutoDraw(False)
        # check responses
        if key_respConfidence.keys in ['', [], None]:  # No response was made
            key_respConfidence.keys = None
        trialsTestingBlock.addData('key_respConfidence.keys',key_respConfidence.keys)
        if key_respConfidence.keys != None:  # we had a response
            trialsTestingBlock.addData('key_respConfidence.rt', key_respConfidence.rt)
        trialsTestingBlock.addData('key_respConfidence.started', key_respConfidence.tStartRefresh)
        trialsTestingBlock.addData('key_respConfidence.stopped', key_respConfidence.tStopRefresh)
        if key_respConfidence.keys != None:
            if 'j' in key_respConfidence.keys and key_respTrial.corr == 0:
                confidenceFalseAlarmCounter += 1
            if 'f' in key_respConfidence.keys and key_respTrial.corr == 1:
                confidenceCorrectRejectionCounter += 1
        
        # ------Prepare to start Routine "Fixation"-------
        continueRoutine = True
        # update component parameters for each repeat
        jitterRange = np.arange(0.9, 1.2, 0.1)
        shuffle(jitterRange)
        jitter = jitterRange[0]
        # keep track of which components have finished
        FixationComponents = [textFixation]
        for thisComponent in FixationComponents:
            thisComponent.tStart = None
            thisComponent.tStop = None
            thisComponent.tStartRefresh = None
            thisComponent.tStopRefresh = None
            if hasattr(thisComponent, 'status'):
                thisComponent.status = NOT_STARTED
        # reset timers
        t = 0
        _timeToFirstFrame = win.getFutureFlipTime(clock="now")
        FixationClock.reset(-_timeToFirstFrame)  # t0 is time of first possible flip
        frameN = -1
        
        # -------Run Routine "Fixation"-------
        while continueRoutine:
            # get current time
            t = FixationClock.getTime()
            tThisFlip = win.getFutureFlipTime(clock=FixationClock)
            tThisFlipGlobal = win.getFutureFlipTime(clock=None)
            frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
            # update/draw components on each frame
            
            # *textFixation* updates
            if textFixation.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
                # keep track of start time/frame for later
                textFixation.frameNStart = frameN  # exact frame index
                textFixation.tStart = t  # local t and not account for scr refresh
                textFixation.tStartRefresh = tThisFlipGlobal  # on global time
                win.timeOnFlip(textFixation, 'tStartRefresh')  # time at next scr refresh
                textFixation.setAutoDraw(True)
            if textFixation.status == STARTED:
                # is it time to stop? (based on global clock, using actual start)
                if tThisFlipGlobal > textFixation.tStartRefresh + jitter-frameTolerance:
                    # keep track of stop time/frame for later
                    textFixation.tStop = t  # not accounting for scr refresh
                    textFixation.frameNStop = frameN  # exact frame index
                    win.timeOnFlip(textFixation, 'tStopRefresh')  # time at next scr refresh
                    textFixation.setAutoDraw(False)
            
            # check for quit (typically the Esc key)
            if endExpNow or defaultKeyboard.getKeys(keyList=["escape"]):
                core.quit()
            
            # check if all components have finished
            if not continueRoutine:  # a component has requested a forced-end of Routine
                break
            continueRoutine = False  # will revert to True if at least one component still running
            for thisComponent in FixationComponents:
                if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
                    continueRoutine = True
                    break  # at least one component has not yet finished
            
            # refresh the screen
            if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
                win.flip()
        
        # -------Ending Routine "Fixation"-------
        for thisComponent in FixationComponents:
            if hasattr(thisComponent, "setAutoDraw"):
                thisComponent.setAutoDraw(False)
        # the Routine "Fixation" was not non-slip safe, so reset the non-slip timer
        routineTimer.reset()
        
        # set up handler to look after randomisation of conditions etc
        trialsTestingCorrect = data.TrialHandler(nReps=nRepsCorrect, method='random', 
            extraInfo=expInfo, originPath=-1,
            trialList=[None],
            seed=None, name='trialsTestingCorrect')
        thisExp.addLoop(trialsTestingCorrect)  # add the loop to the experiment
        thisTrialsTestingCorrect = trialsTestingCorrect.trialList[0]  # so we can initialise stimuli with some values
        # abbreviate parameter names if possible (e.g. rgb = thisTrialsTestingCorrect.rgb)
        if thisTrialsTestingCorrect != None:
            for paramName in thisTrialsTestingCorrect:
                exec('{} = thisTrialsTestingCorrect[paramName]'.format(paramName))
        
        for thisTrialsTestingCorrect in trialsTestingCorrect:
            currentLoop = trialsTestingCorrect
            # abbreviate parameter names if possible (e.g. rgb = thisTrialsTestingCorrect.rgb)
            if thisTrialsTestingCorrect != None:
                for paramName in thisTrialsTestingCorrect:
                    exec('{} = thisTrialsTestingCorrect[paramName]'.format(paramName))
            
            # ------Prepare to start Routine "TestingCorrect"-------
            continueRoutine = True
            routineTimer.add(0.200000)
            # update component parameters for each repeat
            # keep track of which components have finished
            TestingCorrectComponents = [textTestingCorrect, imageTestingCorrect]
            for thisComponent in TestingCorrectComponents:
                thisComponent.tStart = None
                thisComponent.tStop = None
                thisComponent.tStartRefresh = None
                thisComponent.tStopRefresh = None
                if hasattr(thisComponent, 'status'):
                    thisComponent.status = NOT_STARTED
            # reset timers
            t = 0
            _timeToFirstFrame = win.getFutureFlipTime(clock="now")
            TestingCorrectClock.reset(-_timeToFirstFrame)  # t0 is time of first possible flip
            frameN = -1
            
            # -------Run Routine "TestingCorrect"-------
            while continueRoutine and routineTimer.getTime() > 0:
                # get current time
                t = TestingCorrectClock.getTime()
                tThisFlip = win.getFutureFlipTime(clock=TestingCorrectClock)
                tThisFlipGlobal = win.getFutureFlipTime(clock=None)
                frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
                # update/draw components on each frame
                
                # *textTestingCorrect* updates
                if textTestingCorrect.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
                    # keep track of start time/frame for later
                    textTestingCorrect.frameNStart = frameN  # exact frame index
                    textTestingCorrect.tStart = t  # local t and not account for scr refresh
                    textTestingCorrect.tStartRefresh = tThisFlipGlobal  # on global time
                    win.timeOnFlip(textTestingCorrect, 'tStartRefresh')  # time at next scr refresh
                    textTestingCorrect.setAutoDraw(True)
                if textTestingCorrect.status == STARTED:
                    # is it time to stop? (based on global clock, using actual start)
                    if tThisFlipGlobal > textTestingCorrect.tStartRefresh + 0.2-frameTolerance:
                        # keep track of stop time/frame for later
                        textTestingCorrect.tStop = t  # not accounting for scr refresh
                        textTestingCorrect.frameNStop = frameN  # exact frame index
                        win.timeOnFlip(textTestingCorrect, 'tStopRefresh')  # time at next scr refresh
                        textTestingCorrect.setAutoDraw(False)
                
                # *imageTestingCorrect* updates
                if imageTestingCorrect.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
                    # keep track of start time/frame for later
                    imageTestingCorrect.frameNStart = frameN  # exact frame index
                    imageTestingCorrect.tStart = t  # local t and not account for scr refresh
                    imageTestingCorrect.tStartRefresh = tThisFlipGlobal  # on global time
                    win.timeOnFlip(imageTestingCorrect, 'tStartRefresh')  # time at next scr refresh
                    imageTestingCorrect.setAutoDraw(True)
                if imageTestingCorrect.status == STARTED:
                    # is it time to stop? (based on global clock, using actual start)
                    if tThisFlipGlobal > imageTestingCorrect.tStartRefresh + 0.2-frameTolerance:
                        # keep track of stop time/frame for later
                        imageTestingCorrect.tStop = t  # not accounting for scr refresh
                        imageTestingCorrect.frameNStop = frameN  # exact frame index
                        win.timeOnFlip(imageTestingCorrect, 'tStopRefresh')  # time at next scr refresh
                        imageTestingCorrect.setAutoDraw(False)
                
                # check for quit (typically the Esc key)
                if endExpNow or defaultKeyboard.getKeys(keyList=["escape"]):
                    core.quit()
                
                # check if all components have finished
                if not continueRoutine:  # a component has requested a forced-end of Routine
                    break
                continueRoutine = False  # will revert to True if at least one component still running
                for thisComponent in TestingCorrectComponents:
                    if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
                        continueRoutine = True
                        break  # at least one component has not yet finished
                
                # refresh the screen
                if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
                    win.flip()
            
            # -------Ending Routine "TestingCorrect"-------
            for thisComponent in TestingCorrectComponents:
                if hasattr(thisComponent, "setAutoDraw"):
                    thisComponent.setAutoDraw(False)
            thisExp.nextEntry()
            
        # completed nRepsCorrect repeats of 'trialsTestingCorrect'
        
        
        # set up handler to look after randomisation of conditions etc
        trialsTestingIncorrect = data.TrialHandler(nReps=nRepsIncorrect, method='random', 
            extraInfo=expInfo, originPath=-1,
            trialList=[None],
            seed=None, name='trialsTestingIncorrect')
        thisExp.addLoop(trialsTestingIncorrect)  # add the loop to the experiment
        thisTrialsTestingIncorrect = trialsTestingIncorrect.trialList[0]  # so we can initialise stimuli with some values
        # abbreviate parameter names if possible (e.g. rgb = thisTrialsTestingIncorrect.rgb)
        if thisTrialsTestingIncorrect != None:
            for paramName in thisTrialsTestingIncorrect:
                exec('{} = thisTrialsTestingIncorrect[paramName]'.format(paramName))
        
        for thisTrialsTestingIncorrect in trialsTestingIncorrect:
            currentLoop = trialsTestingIncorrect
            # abbreviate parameter names if possible (e.g. rgb = thisTrialsTestingIncorrect.rgb)
            if thisTrialsTestingIncorrect != None:
                for paramName in thisTrialsTestingIncorrect:
                    exec('{} = thisTrialsTestingIncorrect[paramName]'.format(paramName))
            
            # ------Prepare to start Routine "TestingIncorrect"-------
            continueRoutine = True
            routineTimer.add(0.200000)
            # update component parameters for each repeat
            # keep track of which components have finished
            TestingIncorrectComponents = [textTestingIncorrect, imageTestingIncorrect]
            for thisComponent in TestingIncorrectComponents:
                thisComponent.tStart = None
                thisComponent.tStop = None
                thisComponent.tStartRefresh = None
                thisComponent.tStopRefresh = None
                if hasattr(thisComponent, 'status'):
                    thisComponent.status = NOT_STARTED
            # reset timers
            t = 0
            _timeToFirstFrame = win.getFutureFlipTime(clock="now")
            TestingIncorrectClock.reset(-_timeToFirstFrame)  # t0 is time of first possible flip
            frameN = -1
            
            # -------Run Routine "TestingIncorrect"-------
            while continueRoutine and routineTimer.getTime() > 0:
                # get current time
                t = TestingIncorrectClock.getTime()
                tThisFlip = win.getFutureFlipTime(clock=TestingIncorrectClock)
                tThisFlipGlobal = win.getFutureFlipTime(clock=None)
                frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
                # update/draw components on each frame
                
                # *textTestingIncorrect* updates
                if textTestingIncorrect.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
                    # keep track of start time/frame for later
                    textTestingIncorrect.frameNStart = frameN  # exact frame index
                    textTestingIncorrect.tStart = t  # local t and not account for scr refresh
                    textTestingIncorrect.tStartRefresh = tThisFlipGlobal  # on global time
                    win.timeOnFlip(textTestingIncorrect, 'tStartRefresh')  # time at next scr refresh
                    textTestingIncorrect.setAutoDraw(True)
                if textTestingIncorrect.status == STARTED:
                    # is it time to stop? (based on global clock, using actual start)
                    if tThisFlipGlobal > textTestingIncorrect.tStartRefresh + 0.2-frameTolerance:
                        # keep track of stop time/frame for later
                        textTestingIncorrect.tStop = t  # not accounting for scr refresh
                        textTestingIncorrect.frameNStop = frameN  # exact frame index
                        win.timeOnFlip(textTestingIncorrect, 'tStopRefresh')  # time at next scr refresh
                        textTestingIncorrect.setAutoDraw(False)
                
                # *imageTestingIncorrect* updates
                if imageTestingIncorrect.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
                    # keep track of start time/frame for later
                    imageTestingIncorrect.frameNStart = frameN  # exact frame index
                    imageTestingIncorrect.tStart = t  # local t and not account for scr refresh
                    imageTestingIncorrect.tStartRefresh = tThisFlipGlobal  # on global time
                    win.timeOnFlip(imageTestingIncorrect, 'tStartRefresh')  # time at next scr refresh
                    imageTestingIncorrect.setAutoDraw(True)
                if imageTestingIncorrect.status == STARTED:
                    # is it time to stop? (based on global clock, using actual start)
                    if tThisFlipGlobal > imageTestingIncorrect.tStartRefresh + 0.2-frameTolerance:
                        # keep track of stop time/frame for later
                        imageTestingIncorrect.tStop = t  # not accounting for scr refresh
                        imageTestingIncorrect.frameNStop = frameN  # exact frame index
                        win.timeOnFlip(imageTestingIncorrect, 'tStopRefresh')  # time at next scr refresh
                        imageTestingIncorrect.setAutoDraw(False)
                
                # check for quit (typically the Esc key)
                if endExpNow or defaultKeyboard.getKeys(keyList=["escape"]):
                    core.quit()
                
                # check if all components have finished
                if not continueRoutine:  # a component has requested a forced-end of Routine
                    break
                continueRoutine = False  # will revert to True if at least one component still running
                for thisComponent in TestingIncorrectComponents:
                    if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
                        continueRoutine = True
                        break  # at least one component has not yet finished
                
                # refresh the screen
                if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
                    win.flip()
            
            # -------Ending Routine "TestingIncorrect"-------
            for thisComponent in TestingIncorrectComponents:
                if hasattr(thisComponent, "setAutoDraw"):
                    thisComponent.setAutoDraw(False)
            thisExp.nextEntry()
            
        # completed nRepsIncorrect repeats of 'trialsTestingIncorrect'
        
        
        # ------Prepare to start Routine "TestEndCode"-------
        continueRoutine = True
        # update component parameters for each repeat
        currentTestWord += 1
        answered = False
        # keep track of which components have finished
        TestEndCodeComponents = []
        for thisComponent in TestEndCodeComponents:
            thisComponent.tStart = None
            thisComponent.tStop = None
            thisComponent.tStartRefresh = None
            thisComponent.tStopRefresh = None
            if hasattr(thisComponent, 'status'):
                thisComponent.status = NOT_STARTED
        # reset timers
        t = 0
        _timeToFirstFrame = win.getFutureFlipTime(clock="now")
        TestEndCodeClock.reset(-_timeToFirstFrame)  # t0 is time of first possible flip
        frameN = -1
        
        # -------Run Routine "TestEndCode"-------
        while continueRoutine:
            # get current time
            t = TestEndCodeClock.getTime()
            tThisFlip = win.getFutureFlipTime(clock=TestEndCodeClock)
            tThisFlipGlobal = win.getFutureFlipTime(clock=None)
            frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
            # update/draw components on each frame
            
            # check for quit (typically the Esc key)
            if endExpNow or defaultKeyboard.getKeys(keyList=["escape"]):
                core.quit()
            
            # check if all components have finished
            if not continueRoutine:  # a component has requested a forced-end of Routine
                break
            continueRoutine = False  # will revert to True if at least one component still running
            for thisComponent in TestEndCodeComponents:
                if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
                    continueRoutine = True
                    break  # at least one component has not yet finished
            
            # refresh the screen
            if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
                win.flip()
        
        # -------Ending Routine "TestEndCode"-------
        for thisComponent in TestEndCodeComponents:
            if hasattr(thisComponent, "setAutoDraw"):
                thisComponent.setAutoDraw(False)
        # the Routine "TestEndCode" was not non-slip safe, so reset the non-slip timer
        routineTimer.reset()
    # completed numberTestTrials repeats of 'trialsTestingBlock'
    
    
    # ------Prepare to start Routine "BlockSelect"-------
    continueRoutine = True
    # update component parameters for each repeat
    blocksRemaining = numberOfBlocks - currentBlockIndex - 1
    
    if currentLevelIndex == 0:
        if errorCounterCurrentBlock >= 9 and errorCounterCurrentBlock <= 12:
            currentLevelIndex += 1
        if errorCounterCurrentBlock <= 8:
            currentLevelIndex += 2
    
    if currentLevelIndex == 1:
        if errorCounterCurrentBlock >= 18:
            currentLevelIndex -= 1
        if errorCounterCurrentBlock >= 9 and errorCounterCurrentBlock <= 12:
            currentLevelIndex += 1
        if errorCounterCurrentBlock <= 8:
            currentLevelIndex += 2
    
    if currentLevelIndex == 2:
        if errorCounterCurrentBlock >= 18:
            currentLevelIndex -= 1
        if errorCounterCurrentBlock <= 12:
            currentLevelIndex += 1
            
    if currentLevelIndex == 3:
        if errorCounterCurrentBlock >= 18:
            currentLevelIndex -= 1
    
    #if blocksRemaining != 0:
    #    remainingErrorRate = (50 - errorCounter) // blocksRemaining
    #else:
    #    remainingErrorsRate = (50 - errorCounter)
    #
    #print(remainingErrorRate)
    
    #set difficulty level for the next block
    currentDifficultyLevel = difficultyLevels[currentLevelIndex]
    
    print("Next Level: " + str(currentLevelIndex))
    # keep track of which components have finished
    BlockSelectComponents = []
    for thisComponent in BlockSelectComponents:
        thisComponent.tStart = None
        thisComponent.tStop = None
        thisComponent.tStartRefresh = None
        thisComponent.tStopRefresh = None
        if hasattr(thisComponent, 'status'):
            thisComponent.status = NOT_STARTED
    # reset timers
    t = 0
    _timeToFirstFrame = win.getFutureFlipTime(clock="now")
    BlockSelectClock.reset(-_timeToFirstFrame)  # t0 is time of first possible flip
    frameN = -1
    
    # -------Run Routine "BlockSelect"-------
    while continueRoutine:
        # get current time
        t = BlockSelectClock.getTime()
        tThisFlip = win.getFutureFlipTime(clock=BlockSelectClock)
        tThisFlipGlobal = win.getFutureFlipTime(clock=None)
        frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
        # update/draw components on each frame
        
        # check for quit (typically the Esc key)
        if endExpNow or defaultKeyboard.getKeys(keyList=["escape"]):
            core.quit()
        
        # check if all components have finished
        if not continueRoutine:  # a component has requested a forced-end of Routine
            break
        continueRoutine = False  # will revert to True if at least one component still running
        for thisComponent in BlockSelectComponents:
            if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
                continueRoutine = True
                break  # at least one component has not yet finished
        
        # refresh the screen
        if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
            win.flip()
    
    # -------Ending Routine "BlockSelect"-------
    for thisComponent in BlockSelectComponents:
        if hasattr(thisComponent, "setAutoDraw"):
            thisComponent.setAutoDraw(False)
    # the Routine "BlockSelect" was not non-slip safe, so reset the non-slip timer
    routineTimer.reset()
    
    # ------Prepare to start Routine "TestingBlockEnd"-------
    continueRoutine = True
    # update component parameters for each repeat
    keyTestBlockEnd.keys = []
    keyTestBlockEnd.rt = []
    _keyTestBlockEnd_allKeys = []
    # keep track of which components have finished
    TestingBlockEndComponents = [textTestBlockEnd, keyTestBlockEnd]
    for thisComponent in TestingBlockEndComponents:
        thisComponent.tStart = None
        thisComponent.tStop = None
        thisComponent.tStartRefresh = None
        thisComponent.tStopRefresh = None
        if hasattr(thisComponent, 'status'):
            thisComponent.status = NOT_STARTED
    # reset timers
    t = 0
    _timeToFirstFrame = win.getFutureFlipTime(clock="now")
    TestingBlockEndClock.reset(-_timeToFirstFrame)  # t0 is time of first possible flip
    frameN = -1
    
    # -------Run Routine "TestingBlockEnd"-------
    while continueRoutine:
        # get current time
        t = TestingBlockEndClock.getTime()
        tThisFlip = win.getFutureFlipTime(clock=TestingBlockEndClock)
        tThisFlipGlobal = win.getFutureFlipTime(clock=None)
        frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
        # update/draw components on each frame
        
        # *textTestBlockEnd* updates
        if textTestBlockEnd.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
            # keep track of start time/frame for later
            textTestBlockEnd.frameNStart = frameN  # exact frame index
            textTestBlockEnd.tStart = t  # local t and not account for scr refresh
            textTestBlockEnd.tStartRefresh = tThisFlipGlobal  # on global time
            win.timeOnFlip(textTestBlockEnd, 'tStartRefresh')  # time at next scr refresh
            textTestBlockEnd.setAutoDraw(True)
        
        # *keyTestBlockEnd* updates
        waitOnFlip = False
        if keyTestBlockEnd.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
            # keep track of start time/frame for later
            keyTestBlockEnd.frameNStart = frameN  # exact frame index
            keyTestBlockEnd.tStart = t  # local t and not account for scr refresh
            keyTestBlockEnd.tStartRefresh = tThisFlipGlobal  # on global time
            win.timeOnFlip(keyTestBlockEnd, 'tStartRefresh')  # time at next scr refresh
            keyTestBlockEnd.status = STARTED
            # keyboard checking is just starting
            waitOnFlip = True
            win.callOnFlip(keyTestBlockEnd.clock.reset)  # t=0 on next screen flip
            win.callOnFlip(keyTestBlockEnd.clearEvents, eventType='keyboard')  # clear events on next screen flip
        if keyTestBlockEnd.status == STARTED and not waitOnFlip:
            theseKeys = keyTestBlockEnd.getKeys(keyList=['space'], waitRelease=False)
            _keyTestBlockEnd_allKeys.extend(theseKeys)
            if len(_keyTestBlockEnd_allKeys):
                keyTestBlockEnd.keys = _keyTestBlockEnd_allKeys[-1].name  # just the last key pressed
                keyTestBlockEnd.rt = _keyTestBlockEnd_allKeys[-1].rt
                # a response ends the routine
                continueRoutine = False
        
        # check for quit (typically the Esc key)
        if endExpNow or defaultKeyboard.getKeys(keyList=["escape"]):
            core.quit()
        
        # check if all components have finished
        if not continueRoutine:  # a component has requested a forced-end of Routine
            break
        continueRoutine = False  # will revert to True if at least one component still running
        for thisComponent in TestingBlockEndComponents:
            if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
                continueRoutine = True
                break  # at least one component has not yet finished
        
        # refresh the screen
        if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
            win.flip()
    
    # -------Ending Routine "TestingBlockEnd"-------
    for thisComponent in TestingBlockEndComponents:
        if hasattr(thisComponent, "setAutoDraw"):
            thisComponent.setAutoDraw(False)
    #reset word counters
    currentEncodingWord = 0
    currentTestWord = 0
    correctCounterCurrentBlock = 0
    
    #increment block counter
    currentBlockIndex += 1
    # the Routine "TestingBlockEnd" was not non-slip safe, so reset the non-slip timer
    routineTimer.reset()
    thisExp.nextEntry()
    
# completed numberOfBlocks repeats of 'trialsExperimentBlock'


# ------Prepare to start Routine "ExperimentEnd"-------
continueRoutine = True
# update component parameters for each repeat
keyExperimentEnd.keys = []
keyExperimentEnd.rt = []
_keyExperimentEnd_allKeys = []
# keep track of which components have finished
ExperimentEndComponents = [textExperimentEnd, keyExperimentEnd]
for thisComponent in ExperimentEndComponents:
    thisComponent.tStart = None
    thisComponent.tStop = None
    thisComponent.tStartRefresh = None
    thisComponent.tStopRefresh = None
    if hasattr(thisComponent, 'status'):
        thisComponent.status = NOT_STARTED
# reset timers
t = 0
_timeToFirstFrame = win.getFutureFlipTime(clock="now")
ExperimentEndClock.reset(-_timeToFirstFrame)  # t0 is time of first possible flip
frameN = -1

# -------Run Routine "ExperimentEnd"-------
while continueRoutine:
    # get current time
    t = ExperimentEndClock.getTime()
    tThisFlip = win.getFutureFlipTime(clock=ExperimentEndClock)
    tThisFlipGlobal = win.getFutureFlipTime(clock=None)
    frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
    # update/draw components on each frame
    
    # *textExperimentEnd* updates
    if textExperimentEnd.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
        # keep track of start time/frame for later
        textExperimentEnd.frameNStart = frameN  # exact frame index
        textExperimentEnd.tStart = t  # local t and not account for scr refresh
        textExperimentEnd.tStartRefresh = tThisFlipGlobal  # on global time
        win.timeOnFlip(textExperimentEnd, 'tStartRefresh')  # time at next scr refresh
        textExperimentEnd.setAutoDraw(True)
    
    # *keyExperimentEnd* updates
    waitOnFlip = False
    if keyExperimentEnd.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
        # keep track of start time/frame for later
        keyExperimentEnd.frameNStart = frameN  # exact frame index
        keyExperimentEnd.tStart = t  # local t and not account for scr refresh
        keyExperimentEnd.tStartRefresh = tThisFlipGlobal  # on global time
        win.timeOnFlip(keyExperimentEnd, 'tStartRefresh')  # time at next scr refresh
        keyExperimentEnd.status = STARTED
        # keyboard checking is just starting
        waitOnFlip = True
        win.callOnFlip(keyExperimentEnd.clock.reset)  # t=0 on next screen flip
        win.callOnFlip(keyExperimentEnd.clearEvents, eventType='keyboard')  # clear events on next screen flip
    if keyExperimentEnd.status == STARTED and not waitOnFlip:
        theseKeys = keyExperimentEnd.getKeys(keyList=['space'], waitRelease=False)
        _keyExperimentEnd_allKeys.extend(theseKeys)
        if len(_keyExperimentEnd_allKeys):
            keyExperimentEnd.keys = _keyExperimentEnd_allKeys[-1].name  # just the last key pressed
            keyExperimentEnd.rt = _keyExperimentEnd_allKeys[-1].rt
            # a response ends the routine
            continueRoutine = False
    
    # check for quit (typically the Esc key)
    if endExpNow or defaultKeyboard.getKeys(keyList=["escape"]):
        core.quit()
    
    # check if all components have finished
    if not continueRoutine:  # a component has requested a forced-end of Routine
        break
    continueRoutine = False  # will revert to True if at least one component still running
    for thisComponent in ExperimentEndComponents:
        if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
            continueRoutine = True
            break  # at least one component has not yet finished
    
    # refresh the screen
    if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
        win.flip()

# -------Ending Routine "ExperimentEnd"-------
for thisComponent in ExperimentEndComponents:
    if hasattr(thisComponent, "setAutoDraw"):
        thisComponent.setAutoDraw(False)
#thisExp.saveAsWideText("test.csv")

#add total correct guesses
thisExp.addData('Correct', correctCounter)
thisExp.addData('Incorrect (Counting Unanswered)', errorCounter)
thisExp.addData('Incorrect (Minus Unanswered)', errorCounter - unansweredCounter)
thisExp.addData('Hits', hitCounter)
thisExp.addData('Misses', missCounter)
thisExp.addData('CorrectRejection', correctRejectionCounter)
thisExp.addData('FalseAlarm', falseAlarmCounter)
thisExp.addData('Unanswered', unansweredCounter)
thisExp.addData('Low Confidence Correct Rejection', confidenceCorrectRejectionCounter)
thisExp.addData('High Confidence False Alarm', confidenceFalseAlarmCounter)

#print(thisExp.getAllEntries())

dat = pd.DataFrame.from_dict(thisExp.getAllEntries())

newData = dat[['WordItem', 'OldNew', 'key_respTrial.corr', 'key_respConfidence.keys', 'Correct', 'Incorrect (Counting Unanswered)', 'Incorrect (Minus Unanswered)', 'Hits', 'Misses', 'CorrectRejection', 'FalseAlarm', 'Unanswered', 'Low Confidence Correct Rejection', 'High Confidence False Alarm']]

newData.to_csv('data\%s_SUMMARY_%s .csv' % (expInfo['participant'], expInfo['date']))
# the Routine "ExperimentEnd" was not non-slip safe, so reset the non-slip timer
routineTimer.reset()

# Flip one final time so any remaining win.callOnFlip() 
# and win.timeOnFlip() tasks get executed before quitting
win.flip()

# these shouldn't be strictly necessary (should auto-save)
thisExp.saveAsWideText(filename+'.csv', delim='auto')
thisExp.saveAsPickle(filename)
logging.flush()
# make sure everything is closed down
if eyetracker:
    eyetracker.setConnectionState(False)
thisExp.abort()  # or data files will save again on exit
win.close()
core.quit()
